/* Utils.c generated by valac 0.38.10, the Vala compiler
 * generated from Utils.vala, do not modify */

/**/
/*  Copyright (C) 2012 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <meta/window.h>
#include <libbamf/libbamf.h>
#include <gio/gdesktopappinfo.h>
#include <plank.h>
#include <gio/gio.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <meta/workspace.h>
#include <meta/screen.h>
#include <meta/display.h>
#include <meta/meta-window-actor.h>
#include <meta/boxes.h>
#include <clutter/clutter.h>
#include <meta/meta-shaped-texture.h>
#include <float.h>
#include <math.h>
#include <meta/prefs.h>
#include <meta/compositor.h>
#include <meta/meta-backend.h>
#include <meta/main.h>
#include <meta/meta-settings.h>
#include <config.h>
#include <gobject/gvaluecollector.h>


#define GALA_TYPE_UTILS (gala_utils_get_type ())
#define GALA_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_UTILS, GalaUtils))
#define GALA_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_UTILS, GalaUtilsClass))
#define GALA_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_UTILS))
#define GALA_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_UTILS))
#define GALA_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_UTILS, GalaUtilsClass))

typedef struct _GalaUtils GalaUtils;
typedef struct _GalaUtilsClass GalaUtilsClass;
typedef struct _GalaUtilsPrivate GalaUtilsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _GalaParamSpecUtils GalaParamSpecUtils;

struct _GalaUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GalaUtilsPrivate * priv;
};

struct _GalaUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (GalaUtils *self);
};

struct _Block1Data {
	int _ref_count_;
	guint32* xids;
	gint xids_length1;
};

struct _Block2Data {
	int _ref_count_;
	cairo_surface_t* surface;
};

struct _GalaParamSpecUtils {
	GParamSpec parent_instance;
};


static gpointer gala_utils_parent_class = NULL;
static GHashTable* gala_utils_xid_pixbuf_cache;
static GHashTable* gala_utils_xid_pixbuf_cache = NULL;
static GHashTable* gala_utils_icon_pixbuf_cache;
static GHashTable* gala_utils_icon_pixbuf_cache = NULL;
static guint gala_utils_cache_clear_timeout;
static guint gala_utils_cache_clear_timeout = (guint) 0;
static GdkPixbuf* gala_utils_close_pixbuf;
static GdkPixbuf* gala_utils_close_pixbuf = NULL;
static GdkPixbuf* gala_utils_resize_pixbuf;
static GdkPixbuf* gala_utils_resize_pixbuf = NULL;

gpointer gala_utils_ref (gpointer instance);
void gala_utils_unref (gpointer instance);
GParamSpec* gala_param_spec_utils (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gala_value_set_utils (GValue* value, gpointer v_object);
void gala_value_take_utils (GValue* value, gpointer v_object);
gpointer gala_value_get_utils (const GValue* value);
GType gala_utils_get_type (void) G_GNUC_CONST;
static GalaUtils* gala_utils_new (void);
static GalaUtils* gala_utils_construct (GType object_type);
static void gala_utils_clean_icon_cache (guint32* xids, int xids_length1);
static gboolean _vala_uint32_array_contains (guint32 * stack, int stack_length, guint32 needle);
void gala_utils_request_clean_icon_cache (guint32* xids, int xids_length1);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block1Data* _data1_);
static gboolean __lambda6_ (Block1Data* _data1_);
static gboolean ___lambda6__gsource_func (gpointer self);
static gboolean ___lambda5__gsource_func (gpointer self);
GdkPixbuf* gala_utils_get_icon_for_window (MetaWindow* window, gint size, gint scale, gboolean ignore_cache);
GdkPixbuf* gala_utils_get_icon_for_xid (guint32 xid, gint size, gint scale, gboolean ignore_cache);
static GdkPixbuf* gala_utils_get_icon_for_application (BamfApplication* app, gint size, gint scale, gboolean ignore_cache);
MetaWindow* gala_utils_get_next_window (MetaWorkspace* workspace, gboolean backward);
guint gala_utils_get_n_windows (MetaWorkspace* workspace);
ClutterActor* gala_utils_get_window_actor_snapshot (MetaWindowActor* actor, MetaRectangle* inner_rect, MetaRectangle* outer_rect);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block2Data* _data2_, cairo_t* cr);
static gboolean ___lambda7__clutter_canvas_draw (ClutterCanvas* _sender, cairo_t* cr, gint width, gint height, gpointer self);
void gala_utils_bell (MetaScreen* screen);
GdkPixbuf* gala_utils_get_close_button_pixbuf (void);
ClutterActor* gala_utils_create_close_button (void);
GdkPixbuf* gala_utils_get_resize_button_pixbuf (void);
ClutterActor* gala_utils_create_resize_button (void);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void gala_utils_finalize (GalaUtils * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static GalaUtils* gala_utils_construct (GType object_type) {
	GalaUtils* self = NULL;
	self = (GalaUtils*) g_type_create_instance (object_type);
	return self;
}


static GalaUtils* gala_utils_new (void) {
	return gala_utils_construct (GALA_TYPE_UTILS);
}


/**
 * Clean icon caches
 */
static guint64 uint64_parse (const gchar* str) {
	guint64 result = 0ULL;
	const gchar* _tmp0_;
	guint64 _tmp1_;
	g_return_val_if_fail (str != NULL, 0ULL);
	_tmp0_ = str;
	_tmp1_ = g_ascii_strtoull (_tmp0_, NULL, (guint) 0);
	result = _tmp1_;
	return result;
}


static gboolean _vala_uint32_array_contains (guint32 * stack, int stack_length, guint32 needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void gala_utils_clean_icon_cache (guint32* xids, int xids_length1) {
	GList* list = NULL;
	GHashTable* _tmp0_;
	GList* _tmp1_;
	GList* pixbuf_list = NULL;
	GHashTable* _tmp2_;
	GList* _tmp3_;
	GList* icon_list = NULL;
	GHashTable* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	_tmp0_ = gala_utils_xid_pixbuf_cache;
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
	list = _tmp1_;
	_tmp2_ = gala_utils_icon_pixbuf_cache;
	_tmp3_ = g_hash_table_get_values (_tmp2_);
	pixbuf_list = _tmp3_;
	_tmp4_ = gala_utils_icon_pixbuf_cache;
	_tmp5_ = g_hash_table_get_keys (_tmp4_);
	icon_list = _tmp5_;
	_tmp6_ = list;
	{
		GList* xid_key_collection = NULL;
		GList* xid_key_it = NULL;
		xid_key_collection = _tmp6_;
		for (xid_key_it = xid_key_collection; xid_key_it != NULL; xid_key_it = xid_key_it->next) {
			const gchar* xid_key = NULL;
			xid_key = (const gchar*) xid_key_it->data;
			{
				guint32 xid = 0U;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				guint64 _tmp12_;
				guint32 _tmp13_;
				guint32 _tmp14_;
				guint32* _tmp15_;
				gint _tmp15__length1;
				_tmp7_ = xid_key;
				_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "::", 0);
				_tmp10_ = _tmp9_;
				_tmp10__length1 = _vala_array_length (_tmp8_);
				_tmp11_ = _tmp10_[0];
				_tmp12_ = uint64_parse (_tmp11_);
				_tmp13_ = (guint32) _tmp12_;
				_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
				xid = _tmp13_;
				_tmp14_ = xid;
				_tmp15_ = xids;
				_tmp15__length1 = xids_length1;
				if (!_vala_uint32_array_contains (_tmp15_, _tmp15__length1, _tmp14_)) {
					GdkPixbuf* pixbuf = NULL;
					GHashTable* _tmp16_;
					const gchar* _tmp17_;
					gconstpointer _tmp18_;
					GdkPixbuf* _tmp19_;
					GHashTable* _tmp33_;
					const gchar* _tmp34_;
					_tmp16_ = gala_utils_xid_pixbuf_cache;
					_tmp17_ = xid_key;
					_tmp18_ = g_hash_table_lookup (_tmp16_, _tmp17_);
					_tmp19_ = _g_object_ref0 ((GdkPixbuf*) _tmp18_);
					pixbuf = _tmp19_;
					{
						gint j = 0;
						j = 0;
						{
							gboolean _tmp20_ = FALSE;
							_tmp20_ = TRUE;
							while (TRUE) {
								gint _tmp22_;
								GList* _tmp23_;
								guint _tmp24_;
								GList* _tmp25_;
								gint _tmp26_;
								gconstpointer _tmp27_;
								GdkPixbuf* _tmp28_;
								if (!_tmp20_) {
									gint _tmp21_;
									_tmp21_ = j;
									j = _tmp21_ + 1;
								}
								_tmp20_ = FALSE;
								_tmp22_ = j;
								_tmp23_ = pixbuf_list;
								_tmp24_ = g_list_length (_tmp23_);
								if (!(((guint) _tmp22_) < _tmp24_)) {
									break;
								}
								_tmp25_ = pixbuf_list;
								_tmp26_ = j;
								_tmp27_ = g_list_nth_data (_tmp25_, (guint) _tmp26_);
								_tmp28_ = pixbuf;
								if (((GdkPixbuf*) _tmp27_) == _tmp28_) {
									GHashTable* _tmp29_;
									GList* _tmp30_;
									gint _tmp31_;
									gconstpointer _tmp32_;
									_tmp29_ = gala_utils_xid_pixbuf_cache;
									_tmp30_ = icon_list;
									_tmp31_ = j;
									_tmp32_ = g_list_nth_data (_tmp30_, (guint) _tmp31_);
									g_hash_table_remove (_tmp29_, (const gchar*) _tmp32_);
								}
							}
						}
					}
					_tmp33_ = gala_utils_xid_pixbuf_cache;
					_tmp34_ = xid_key;
					g_hash_table_remove (_tmp33_, _tmp34_);
					_g_object_unref0 (pixbuf);
				}
			}
		}
	}
	_g_list_free0 (icon_list);
	_g_list_free0 (pixbuf_list);
	_g_list_free0 (list);
}


/**
 * Marks the given xids as no longer needed, the corresponding icons
 * may be freed now. Mainly for internal purposes.
 *
 * @param xids The xids of the window that no longer need icons
 */
static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean __lambda6_ (Block1Data* _data1_) {
	gboolean result = FALSE;
	guint32* _tmp0_;
	gint _tmp0__length1;
	_tmp0_ = _data1_->xids;
	_tmp0__length1 = _data1_->xids_length1;
	gala_utils_clean_icon_cache (_tmp0_, _tmp0__length1);
	result = FALSE;
	return result;
}


static gboolean ___lambda6__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda6_ (self);
	return result;
}


static gboolean __lambda5_ (Block1Data* _data1_) {
	gboolean result = FALSE;
	gala_utils_cache_clear_timeout = (guint) 0;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda6__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	result = FALSE;
	return result;
}


static gboolean ___lambda5__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda5_ (self);
	return result;
}


void gala_utils_request_clean_icon_cache (guint32* xids, int xids_length1) {
	Block1Data* _data1_;
	guint32* _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	guint _tmp3_;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = xids;
	_tmp0__length1 = xids_length1;
	_data1_->xids = _tmp0_;
	_data1_->xids_length1 = _tmp0__length1;
	_tmp1_ = gala_utils_cache_clear_timeout;
	if (_tmp1_ > ((guint) 0)) {
		guint _tmp2_;
		_tmp2_ = gala_utils_cache_clear_timeout;
		g_source_remove (_tmp2_);
	}
	_tmp3_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 30, ___lambda5__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	gala_utils_cache_clear_timeout = _tmp3_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


/**
 * Returns a pixbuf for the application of this window or a default icon
 *
 * @param window       The window to get an icon for
 * @param size         The size of the icon
 * @param scale        The desired scale of the icon
 * @param ignore_cache Should not be necessary in most cases, if you care about the icon
 *                     being loaded correctly, you should consider using the WindowIcon class
 */
GdkPixbuf* gala_utils_get_icon_for_window (MetaWindow* window, gint size, gint scale, gboolean ignore_cache) {
	GdkPixbuf* result = NULL;
	MetaWindow* _tmp0_;
	Window _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	GdkPixbuf* _tmp5_;
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = window;
	_tmp1_ = meta_window_get_xwindow (_tmp0_);
	_tmp2_ = size;
	_tmp3_ = scale;
	_tmp4_ = ignore_cache;
	_tmp5_ = gala_utils_get_icon_for_xid ((guint32) _tmp1_, _tmp2_, _tmp3_, _tmp4_);
	result = _tmp5_;
	return result;
}


/**
 * Returns a pixbuf for a given xid or a default icon
 *
 * @see get_icon_for_window
 */
GdkPixbuf* gala_utils_get_icon_for_xid (guint32 xid, gint size, gint scale, gboolean ignore_cache) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _result_ = NULL;
	gchar* xid_key = NULL;
	guint32 _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	BamfApplication* app = NULL;
	BamfMatcher* _tmp10_;
	BamfMatcher* _tmp11_;
	guint32 _tmp12_;
	BamfApplication* _tmp13_;
	BamfApplication* _tmp14_;
	BamfApplication* _tmp15_;
	BamfApplication* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gboolean _tmp19_;
	GdkPixbuf* _tmp20_;
	GHashTable* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	GdkPixbuf* _tmp24_;
	GdkPixbuf* _tmp25_;
	_result_ = NULL;
	_tmp0_ = xid;
	_tmp1_ = size;
	_tmp2_ = g_strdup_printf ("%u::%i", (guint) _tmp0_, _tmp1_);
	xid_key = _tmp2_;
	_tmp4_ = ignore_cache;
	if (!_tmp4_) {
		GHashTable* _tmp5_;
		const gchar* _tmp6_;
		gconstpointer _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
		_tmp5_ = gala_utils_xid_pixbuf_cache;
		_tmp6_ = xid_key;
		_tmp7_ = g_hash_table_lookup (_tmp5_, _tmp6_);
		_tmp8_ = _g_object_ref0 ((GdkPixbuf*) _tmp7_);
		_g_object_unref0 (_result_);
		_result_ = _tmp8_;
		_tmp9_ = _result_;
		_tmp3_ = _tmp9_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		result = _result_;
		_g_free0 (xid_key);
		return result;
	}
	_tmp10_ = bamf_matcher_get_default ();
	_tmp11_ = _tmp10_;
	_tmp12_ = xid;
	_tmp13_ = bamf_matcher_get_application_for_xid (_tmp11_, _tmp12_);
	_tmp14_ = _g_object_ref0 (_tmp13_);
	_tmp15_ = _tmp14_;
	_g_object_unref0 (_tmp11_);
	app = _tmp15_;
	_tmp16_ = app;
	_tmp17_ = size;
	_tmp18_ = scale;
	_tmp19_ = ignore_cache;
	_tmp20_ = gala_utils_get_icon_for_application (_tmp16_, _tmp17_, _tmp18_, _tmp19_);
	_g_object_unref0 (_result_);
	_result_ = _tmp20_;
	_tmp21_ = gala_utils_xid_pixbuf_cache;
	_tmp22_ = xid_key;
	_tmp23_ = g_strdup (_tmp22_);
	_tmp24_ = _result_;
	_tmp25_ = _g_object_ref0 (_tmp24_);
	g_hash_table_insert (_tmp21_, _tmp23_, _tmp25_);
	result = _result_;
	_g_object_unref0 (app);
	_g_free0 (xid_key);
	return result;
}


/**
 * Returns a pixbuf for this application or a default icon
 *
 * @see get_icon_for_window
 */
static GdkPixbuf* gala_utils_get_icon_for_application (BamfApplication* app, gint size, gint scale, gboolean ignore_cache) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* image = NULL;
	gboolean not_cached = FALSE;
	gchar* icon = NULL;
	gchar* icon_key = NULL;
	gboolean _tmp0_ = FALSE;
	BamfApplication* _tmp1_;
	GdkPixbuf* _tmp33_;
	GdkPixbuf* _tmp54_;
	gboolean _tmp67_ = FALSE;
	gint _tmp68_;
	gint _tmp69_;
	GdkPixbuf* _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	gboolean _tmp84_;
	GError * _inner_error_ = NULL;
	image = NULL;
	not_cached = FALSE;
	icon = NULL;
	icon_key = NULL;
	_tmp1_ = app;
	if (_tmp1_ != NULL) {
		BamfApplication* _tmp2_;
		const gchar* _tmp3_;
		_tmp2_ = app;
		_tmp3_ = bamf_application_get_desktop_file (_tmp2_);
		_tmp0_ = _tmp3_ != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GDesktopAppInfo* appinfo = NULL;
		BamfApplication* _tmp4_;
		const gchar* _tmp5_;
		GDesktopAppInfo* _tmp6_;
		GDesktopAppInfo* _tmp7_;
		_tmp4_ = app;
		_tmp5_ = bamf_application_get_desktop_file (_tmp4_);
		_tmp6_ = g_desktop_app_info_new_from_filename (_tmp5_);
		appinfo = _tmp6_;
		_tmp7_ = appinfo;
		if (_tmp7_ != NULL) {
			GDesktopAppInfo* _tmp8_;
			GIcon* _tmp9_;
			gchar* _tmp10_;
			const gchar* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gchar* _tmp14_;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_;
			_tmp8_ = appinfo;
			_tmp9_ = g_app_info_get_icon ((GAppInfo*) _tmp8_);
			_tmp10_ = plank_drawing_service_get_icon_from_gicon (_tmp9_);
			_g_free0 (icon);
			icon = _tmp10_;
			_tmp11_ = icon;
			_tmp12_ = size;
			_tmp13_ = scale;
			_tmp14_ = g_strdup_printf ("%s::%i::%i", _tmp11_, _tmp12_, _tmp13_);
			_g_free0 (icon_key);
			icon_key = _tmp14_;
			_tmp16_ = ignore_cache;
			if (_tmp16_) {
				_tmp15_ = TRUE;
			} else {
				GHashTable* _tmp17_;
				const gchar* _tmp18_;
				gconstpointer _tmp19_;
				GdkPixbuf* _tmp20_;
				GdkPixbuf* _tmp21_;
				_tmp17_ = gala_utils_icon_pixbuf_cache;
				_tmp18_ = icon_key;
				_tmp19_ = g_hash_table_lookup (_tmp17_, _tmp18_);
				_tmp20_ = _g_object_ref0 ((GdkPixbuf*) _tmp19_);
				_g_object_unref0 (image);
				image = _tmp20_;
				_tmp21_ = image;
				_tmp15_ = _tmp21_ == NULL;
			}
			if (_tmp15_) {
				gint scaled_size = 0;
				gint _tmp22_;
				gint _tmp23_;
				cairo_surface_t* surface = NULL;
				const gchar* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				cairo_surface_t* _tmp28_;
				cairo_surface_t* _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
				GdkPixbuf* _tmp32_;
				_tmp22_ = size;
				_tmp23_ = scale;
				scaled_size = _tmp22_ * _tmp23_;
				_tmp24_ = icon;
				_tmp25_ = scaled_size;
				_tmp26_ = scaled_size;
				_tmp27_ = scale;
				_tmp28_ = plank_drawing_service_load_icon_for_scale (_tmp24_, _tmp25_, _tmp26_, _tmp27_);
				surface = _tmp28_;
				_tmp29_ = surface;
				_tmp30_ = scaled_size;
				_tmp31_ = scaled_size;
				_tmp32_ = gdk_pixbuf_get_from_surface (_tmp29_, 0, 0, _tmp30_, _tmp31_);
				_g_object_unref0 (image);
				image = _tmp32_;
				not_cached = TRUE;
				_cairo_surface_destroy0 (surface);
			}
		}
		_g_object_unref0 (appinfo);
	}
	_tmp33_ = image;
	if (_tmp33_ == NULL) {
		{
			GtkIconTheme* icon_theme = NULL;
			GtkIconTheme* _tmp34_;
			gchar* _tmp35_;
			const gchar* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
			gchar* _tmp39_;
			GHashTable* _tmp40_;
			const gchar* _tmp41_;
			gconstpointer _tmp42_;
			GdkPixbuf* _tmp43_;
			GdkPixbuf* _tmp44_;
			_tmp34_ = gtk_icon_theme_get_default ();
			icon_theme = _tmp34_;
			_tmp35_ = g_strdup ("application-default-icon");
			_g_free0 (icon);
			icon = _tmp35_;
			_tmp36_ = icon;
			_tmp37_ = size;
			_tmp38_ = scale;
			_tmp39_ = g_strdup_printf ("%s::%i::%i", _tmp36_, _tmp37_, _tmp38_);
			_g_free0 (icon_key);
			icon_key = _tmp39_;
			_tmp40_ = gala_utils_icon_pixbuf_cache;
			_tmp41_ = icon_key;
			_tmp42_ = g_hash_table_lookup (_tmp40_, _tmp41_);
			_tmp43_ = _g_object_ref0 ((GdkPixbuf*) _tmp42_);
			_g_object_unref0 (image);
			image = _tmp43_;
			_tmp44_ = image;
			if (_tmp44_ == NULL) {
				GdkPixbuf* _tmp45_ = NULL;
				GtkIconTheme* _tmp46_;
				const gchar* _tmp47_;
				gint _tmp48_;
				gint _tmp49_;
				GdkPixbuf* _tmp50_;
				GdkPixbuf* _tmp51_;
				_tmp46_ = icon_theme;
				_tmp47_ = icon;
				_tmp48_ = size;
				_tmp49_ = scale;
				_tmp50_ = gtk_icon_theme_load_icon_for_scale (_tmp46_, _tmp47_, _tmp48_, _tmp49_, 0, &_inner_error_);
				_tmp45_ = _tmp50_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					goto __catch0_g_error;
				}
				_tmp51_ = _tmp45_;
				_tmp45_ = NULL;
				_g_object_unref0 (image);
				image = _tmp51_;
				not_cached = TRUE;
				_g_object_unref0 (_tmp45_);
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp52_;
			const gchar* _tmp53_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp52_ = e;
			_tmp53_ = _tmp52_->message;
			g_warning ("Utils.vala:158: %s", _tmp53_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (icon_key);
			_g_free0 (icon);
			_g_object_unref0 (image);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp54_ = image;
	if (_tmp54_ == NULL) {
		gchar* _tmp55_;
		gint _tmp56_;
		gchar* _tmp57_;
		GHashTable* _tmp58_;
		const gchar* _tmp59_;
		gconstpointer _tmp60_;
		GdkPixbuf* _tmp61_;
		GdkPixbuf* _tmp62_;
		_tmp55_ = g_strdup ("");
		_g_free0 (icon);
		icon = _tmp55_;
		_tmp56_ = size;
		_tmp57_ = g_strdup_printf ("::%i", _tmp56_);
		_g_free0 (icon_key);
		icon_key = _tmp57_;
		_tmp58_ = gala_utils_icon_pixbuf_cache;
		_tmp59_ = icon_key;
		_tmp60_ = g_hash_table_lookup (_tmp58_, _tmp59_);
		_tmp61_ = _g_object_ref0 ((GdkPixbuf*) _tmp60_);
		_g_object_unref0 (image);
		image = _tmp61_;
		_tmp62_ = image;
		if (_tmp62_ == NULL) {
			gint _tmp63_;
			gint _tmp64_;
			GdkPixbuf* _tmp65_;
			GdkPixbuf* _tmp66_;
			_tmp63_ = size;
			_tmp64_ = size;
			_tmp65_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, _tmp63_, _tmp64_);
			_g_object_unref0 (image);
			image = _tmp65_;
			_tmp66_ = image;
			gdk_pixbuf_fill (_tmp66_, (guint32) 0x00000000);
			not_cached = TRUE;
		}
	}
	_tmp68_ = size;
	_tmp69_ = scale;
	_tmp70_ = image;
	_tmp71_ = gdk_pixbuf_get_width (_tmp70_);
	_tmp72_ = _tmp71_;
	if ((_tmp68_ * _tmp69_) != _tmp72_) {
		_tmp67_ = TRUE;
	} else {
		gint _tmp73_;
		gint _tmp74_;
		GdkPixbuf* _tmp75_;
		gint _tmp76_;
		gint _tmp77_;
		_tmp73_ = size;
		_tmp74_ = scale;
		_tmp75_ = image;
		_tmp76_ = gdk_pixbuf_get_height (_tmp75_);
		_tmp77_ = _tmp76_;
		_tmp67_ = (_tmp73_ * _tmp74_) != _tmp77_;
	}
	if (_tmp67_) {
		GdkPixbuf* _tmp78_;
		gint _tmp79_;
		gint _tmp80_;
		gint _tmp81_;
		gint _tmp82_;
		GdkPixbuf* _tmp83_;
		_tmp78_ = image;
		_tmp79_ = size;
		_tmp80_ = scale;
		_tmp81_ = size;
		_tmp82_ = scale;
		_tmp83_ = plank_drawing_service_ar_scale (_tmp78_, _tmp79_ * _tmp80_, _tmp81_ * _tmp82_);
		_g_object_unref0 (image);
		image = _tmp83_;
	}
	_tmp84_ = not_cached;
	if (_tmp84_) {
		GHashTable* _tmp85_;
		const gchar* _tmp86_;
		gchar* _tmp87_;
		GdkPixbuf* _tmp88_;
		GdkPixbuf* _tmp89_;
		_tmp85_ = gala_utils_icon_pixbuf_cache;
		_tmp86_ = icon_key;
		_tmp87_ = g_strdup (_tmp86_);
		_tmp88_ = image;
		_tmp89_ = _g_object_ref0 (_tmp88_);
		g_hash_table_insert (_tmp85_, _tmp87_, _tmp89_);
	}
	result = image;
	_g_free0 (icon_key);
	_g_free0 (icon);
	return result;
}


/**
 * Get the next window that should be active on a workspace right now. Based on
 * stacking order
 *
 * @param workspace The workspace on which to find the window
 * @param backward  Whether to get the previous one instead
 */
MetaWindow* gala_utils_get_next_window (MetaWorkspace* workspace, gboolean backward) {
	MetaWindow* result = NULL;
	MetaScreen* screen = NULL;
	MetaWorkspace* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	MetaDisplay* display = NULL;
	MetaScreen* _tmp3_;
	MetaDisplay* _tmp4_;
	MetaDisplay* _tmp5_;
	MetaWindow* window = NULL;
	MetaDisplay* _tmp6_;
	MetaWorkspace* _tmp7_;
	gboolean _tmp8_;
	MetaWindow* _tmp9_;
	MetaWindow* _tmp10_;
	MetaWindow* _tmp11_;
	g_return_val_if_fail (workspace != NULL, NULL);
	_tmp0_ = workspace;
	_tmp1_ = meta_workspace_get_screen (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	screen = _tmp2_;
	_tmp3_ = screen;
	_tmp4_ = meta_screen_get_display (_tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	display = _tmp5_;
	_tmp6_ = display;
	_tmp7_ = workspace;
	_tmp8_ = backward;
	_tmp9_ = meta_display_get_tab_next (_tmp6_, META_TAB_LIST_NORMAL, _tmp7_, NULL, _tmp8_);
	_tmp10_ = _g_object_ref0 (_tmp9_);
	window = _tmp10_;
	_tmp11_ = window;
	if (_tmp11_ == NULL) {
		MetaDisplay* _tmp12_;
		MetaWorkspace* _tmp13_;
		MetaWindow* _tmp14_;
		MetaWindow* _tmp15_;
		_tmp12_ = display;
		_tmp13_ = workspace;
		_tmp14_ = meta_display_get_tab_current (_tmp12_, META_TAB_LIST_NORMAL, _tmp13_);
		_tmp15_ = _g_object_ref0 (_tmp14_);
		_g_object_unref0 (window);
		window = _tmp15_;
	}
	result = window;
	_g_object_unref0 (display);
	_g_object_unref0 (screen);
	return result;
}


/**
 * Get the number of toplevel windows on a workspace excluding those that are
 * on all workspaces
 *
 * @param workspace The workspace on which to count the windows
 */
guint gala_utils_get_n_windows (MetaWorkspace* workspace) {
	guint result = 0U;
	gint n = 0;
	MetaWorkspace* _tmp0_;
	GList* _tmp1_;
	g_return_val_if_fail (workspace != NULL, 0U);
	n = 0;
	_tmp0_ = workspace;
	_tmp1_ = meta_workspace_list_windows (_tmp0_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			MetaWindow* window = NULL;
			window = (MetaWindow*) window_it->data;
			{
				MetaWindow* _tmp2_;
				gboolean _tmp3_;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				MetaWindow* _tmp6_;
				MetaWindowType _tmp7_;
				MetaWindowType _tmp8_;
				_tmp2_ = window;
				_tmp3_ = meta_window_is_always_on_all_workspaces (_tmp2_);
				if (_tmp3_) {
					continue;
				}
				_tmp6_ = window;
				_tmp7_ = meta_window_get_window_type (_tmp6_);
				_tmp8_ = _tmp7_;
				if (_tmp8_ == META_WINDOW_NORMAL) {
					_tmp5_ = TRUE;
				} else {
					MetaWindow* _tmp9_;
					MetaWindowType _tmp10_;
					MetaWindowType _tmp11_;
					_tmp9_ = window;
					_tmp10_ = meta_window_get_window_type (_tmp9_);
					_tmp11_ = _tmp10_;
					_tmp5_ = _tmp11_ == META_WINDOW_DIALOG;
				}
				if (_tmp5_) {
					_tmp4_ = TRUE;
				} else {
					MetaWindow* _tmp12_;
					MetaWindowType _tmp13_;
					MetaWindowType _tmp14_;
					_tmp12_ = window;
					_tmp13_ = meta_window_get_window_type (_tmp12_);
					_tmp14_ = _tmp13_;
					_tmp4_ = _tmp14_ == META_WINDOW_MODAL_DIALOG;
				}
				if (_tmp4_) {
					gint _tmp15_;
					_tmp15_ = n;
					n = _tmp15_ + 1;
				}
			}
		}
		_g_list_free0 (window_collection);
	}
	result = (guint) n;
	return result;
}


/**
 * Creates an actor showing the current contents of the given WindowActor.
 *
 * @param actor      The actor from which to create a shnapshot
 * @param inner_rect The inner (actually visible) rectangle of the window
 * @param outer_rect The outer (input region) rectangle of the window
 *
 * @return           A copy of the actor at that time or %NULL
 */
static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		_cairo_surface_destroy0 (_data2_->surface);
		g_slice_free (Block2Data, _data2_);
	}
}


static gboolean __lambda7_ (Block2Data* _data2_, cairo_t* cr) {
	gboolean result = FALSE;
	cairo_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_t* _tmp2_;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = cr;
	_tmp1_ = _data2_->surface;
	cairo_set_source_surface (_tmp0_, _tmp1_, (gdouble) 0, (gdouble) 0);
	_tmp2_ = cr;
	cairo_paint (_tmp2_);
	result = FALSE;
	return result;
}


static gboolean ___lambda7__clutter_canvas_draw (ClutterCanvas* _sender, cairo_t* cr, gint width, gint height, gpointer self) {
	gboolean result;
	result = __lambda7_ (self, cr);
	return result;
}


ClutterActor* gala_utils_get_window_actor_snapshot (MetaWindowActor* actor, MetaRectangle* inner_rect, MetaRectangle* outer_rect) {
	ClutterActor* result = NULL;
	Block2Data* _data2_;
	MetaShapedTexture* texture = NULL;
	MetaWindowActor* _tmp0_;
	ClutterActor* _tmp1_;
	MetaShapedTexture* _tmp2_;
	MetaShapedTexture* _tmp3_;
	MetaShapedTexture* _tmp4_;
	MetaRectangle _tmp5_;
	gint _tmp6_;
	MetaRectangle _tmp7_;
	gint _tmp8_;
	MetaRectangle _tmp9_;
	gint _tmp10_;
	MetaRectangle _tmp11_;
	gint _tmp12_;
	MetaRectangle _tmp13_;
	gint _tmp14_;
	MetaRectangle _tmp15_;
	gint _tmp16_;
	cairo_rectangle_int_t _tmp17_ = {0};
	cairo_surface_t* _tmp18_;
	cairo_surface_t* _tmp19_;
	ClutterCanvas* canvas = NULL;
	ClutterCanvas* _tmp20_;
	gulong handler = 0UL;
	ClutterCanvas* _tmp21_;
	gulong _tmp22_;
	ClutterCanvas* _tmp23_;
	MetaRectangle _tmp24_;
	gint _tmp25_;
	MetaRectangle _tmp26_;
	gint _tmp27_;
	ClutterCanvas* _tmp28_;
	gulong _tmp29_;
	ClutterActor* container = NULL;
	ClutterActor* _tmp30_;
	ClutterActor* _tmp31_;
	MetaRectangle _tmp32_;
	gint _tmp33_;
	MetaRectangle _tmp34_;
	gint _tmp35_;
	ClutterActor* _tmp36_;
	ClutterCanvas* _tmp37_;
	g_return_val_if_fail (actor != NULL, NULL);
	g_return_val_if_fail (inner_rect != NULL, NULL);
	g_return_val_if_fail (outer_rect != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_tmp0_ = actor;
	_tmp1_ = meta_window_actor_get_texture (_tmp0_);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, meta_shaped_texture_get_type ()) ? ((MetaShapedTexture*) _tmp1_) : NULL);
	texture = _tmp2_;
	_tmp3_ = texture;
	if (_tmp3_ == NULL) {
		result = NULL;
		_g_object_unref0 (texture);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return result;
	}
	_tmp4_ = texture;
	_tmp5_ = *inner_rect;
	_tmp6_ = _tmp5_.x;
	_tmp7_ = *outer_rect;
	_tmp8_ = _tmp7_.x;
	_tmp9_ = *inner_rect;
	_tmp10_ = _tmp9_.y;
	_tmp11_ = *outer_rect;
	_tmp12_ = _tmp11_.y;
	_tmp13_ = *inner_rect;
	_tmp14_ = _tmp13_.width;
	_tmp15_ = *inner_rect;
	_tmp16_ = _tmp15_.height;
	_tmp17_.x = _tmp6_ - _tmp8_;
	_tmp17_.y = _tmp10_ - _tmp12_;
	_tmp17_.width = _tmp14_;
	_tmp17_.height = _tmp16_;
	_tmp18_ = meta_shaped_texture_get_image (_tmp4_, &_tmp17_);
	_data2_->surface = _tmp18_;
	_tmp19_ = _data2_->surface;
	if (_tmp19_ == NULL) {
		result = NULL;
		_g_object_unref0 (texture);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return result;
	}
	_tmp20_ = (ClutterCanvas*) clutter_canvas_new ();
	canvas = _tmp20_;
	_tmp21_ = canvas;
	_tmp22_ = g_signal_connect_data (_tmp21_, "draw", (GCallback) ___lambda7__clutter_canvas_draw, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	handler = _tmp22_;
	_tmp23_ = canvas;
	_tmp24_ = *inner_rect;
	_tmp25_ = _tmp24_.width;
	_tmp26_ = *inner_rect;
	_tmp27_ = _tmp26_.height;
	clutter_canvas_set_size (_tmp23_, _tmp25_, _tmp27_);
	_tmp28_ = canvas;
	_tmp29_ = handler;
	g_signal_handler_disconnect (_tmp28_, _tmp29_);
	_tmp30_ = clutter_actor_new ();
	g_object_ref_sink (_tmp30_);
	container = _tmp30_;
	_tmp31_ = container;
	_tmp32_ = *inner_rect;
	_tmp33_ = _tmp32_.width;
	_tmp34_ = *inner_rect;
	_tmp35_ = _tmp34_.height;
	clutter_actor_set_size (_tmp31_, (gfloat) _tmp33_, (gfloat) _tmp35_);
	_tmp36_ = container;
	_tmp37_ = canvas;
	clutter_actor_set_content (_tmp36_, (ClutterContent*) _tmp37_);
	result = container;
	_g_object_unref0 (canvas);
	_g_object_unref0 (texture);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}


/**
 * Ring the system bell, will most likely emit a <beep> error sound or, if the
 * audible bell is disabled, flash the screen
 *
 * @param screen The screen to flash, if necessary
 */
void gala_utils_bell (MetaScreen* screen) {
	gboolean _tmp0_;
	g_return_if_fail (screen != NULL);
	_tmp0_ = meta_prefs_bell_is_audible ();
	if (_tmp0_) {
		gdk_beep ();
	} else {
		MetaScreen* _tmp1_;
		MetaDisplay* _tmp2_;
		MetaCompositor* _tmp3_;
		MetaScreen* _tmp4_;
		_tmp1_ = screen;
		_tmp2_ = meta_screen_get_display (_tmp1_);
		_tmp3_ = meta_display_get_compositor (_tmp2_);
		_tmp4_ = screen;
		meta_compositor_flash_screen (_tmp3_, _tmp4_);
	}
}


/**
 * Returns the pixbuf that is used for close buttons throughout gala at a
 * size of 36px
 *
 * @return the close button pixbuf or null if it failed to load
 */
GdkPixbuf* gala_utils_get_close_button_pixbuf (void) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* _tmp11_;
	GError * _inner_error_ = NULL;
	_tmp0_ = gala_utils_close_pixbuf;
	if (_tmp0_ == NULL) {
		gint scale = 0;
		MetaBackend* _tmp1_;
		MetaSettings* _tmp2_;
		gint _tmp3_;
		_tmp1_ = meta_get_backend ();
		_tmp2_ = meta_backend_get_settings (_tmp1_);
		_tmp3_ = meta_settings_get_ui_scaling_factor (_tmp2_);
		scale = _tmp3_;
		{
			GdkPixbuf* _tmp4_ = NULL;
			gint _tmp5_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
			_tmp5_ = scale;
			_tmp6_ = gdk_pixbuf_new_from_resource_at_scale (RESOURCEPATH "/buttons/close.svg", -1, 36 * _tmp5_, TRUE, &_inner_error_);
			_tmp4_ = _tmp6_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch1_g_error;
			}
			_tmp7_ = _tmp4_;
			_tmp4_ = NULL;
			_g_object_unref0 (gala_utils_close_pixbuf);
			gala_utils_close_pixbuf = _tmp7_;
			_g_object_unref0 (_tmp4_);
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp8_ = e;
			_tmp9_ = _tmp8_->message;
			g_warning ("Utils.vala:296: %s", _tmp9_);
			result = NULL;
			_g_error_free0 (e);
			return result;
		}
		__finally1:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp10_ = gala_utils_close_pixbuf;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	result = _tmp11_;
	return result;
}


/**
 * Creates a new reactive ClutterActor at 36px with the close pixbuf
 *
 * @return The close button actor
 */
ClutterActor* gala_utils_create_close_button (void) {
	ClutterActor* result = NULL;
	ClutterTexture* texture = NULL;
	ClutterTexture* _tmp0_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp1_;
	ClutterTexture* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
	_tmp0_ = (ClutterTexture*) clutter_texture_new ();
	g_object_ref_sink (_tmp0_);
	texture = _tmp0_;
	_tmp1_ = gala_utils_get_close_button_pixbuf ();
	pixbuf = _tmp1_;
	_tmp2_ = texture;
	clutter_actor_set_reactive ((ClutterActor*) _tmp2_, TRUE);
	_tmp3_ = pixbuf;
	if (_tmp3_ != NULL) {
		{
			gint _tmp4_ = 0;
			GdkPixbuf* _tmp5_;
			gboolean _tmp6_;
			ClutterTexture* _tmp7_;
			GdkPixbuf* _tmp8_;
			guint8* _tmp9_;
			GdkPixbuf* _tmp10_;
			gboolean _tmp11_;
			GdkPixbuf* _tmp12_;
			gint _tmp13_;
			GdkPixbuf* _tmp14_;
			gint _tmp15_;
			GdkPixbuf* _tmp16_;
			gint _tmp17_;
			_tmp5_ = pixbuf;
			_tmp6_ = gdk_pixbuf_get_has_alpha (_tmp5_);
			if (_tmp6_) {
				_tmp4_ = 4;
			} else {
				_tmp4_ = 3;
			}
			_tmp7_ = texture;
			_tmp8_ = pixbuf;
			_tmp9_ = gdk_pixbuf_get_pixels (_tmp8_);
			_tmp10_ = pixbuf;
			_tmp11_ = gdk_pixbuf_get_has_alpha (_tmp10_);
			_tmp12_ = pixbuf;
			_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
			_tmp14_ = pixbuf;
			_tmp15_ = gdk_pixbuf_get_height (_tmp14_);
			_tmp16_ = pixbuf;
			_tmp17_ = gdk_pixbuf_get_rowstride (_tmp16_);
			clutter_texture_set_from_rgb_data (_tmp7_, _tmp9_, _tmp11_, _tmp13_, _tmp15_, _tmp17_, _tmp4_, 0, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (e);
		}
		__finally2:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (pixbuf);
			_g_object_unref0 (texture);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	} else {
		gint scale = 0;
		MetaBackend* _tmp18_;
		MetaSettings* _tmp19_;
		gint _tmp20_;
		ClutterTexture* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		ClutterTexture* _tmp24_;
		ClutterColor _tmp25_ = {0};
		_tmp18_ = meta_get_backend ();
		_tmp19_ = meta_backend_get_settings (_tmp18_);
		_tmp20_ = meta_settings_get_ui_scaling_factor (_tmp19_);
		scale = _tmp20_;
		_tmp21_ = texture;
		_tmp22_ = scale;
		_tmp23_ = scale;
		clutter_actor_set_size ((ClutterActor*) _tmp21_, (gfloat) (36 * _tmp22_), (gfloat) (36 * _tmp23_));
		_tmp24_ = texture;
		_tmp25_.red = (guint8) 255;
		_tmp25_.green = (guint8) 0;
		_tmp25_.blue = (guint8) 0;
		_tmp25_.alpha = (guint8) 255;
		clutter_actor_set_background_color ((ClutterActor*) _tmp24_, &_tmp25_);
	}
	result = (ClutterActor*) texture;
	_g_object_unref0 (pixbuf);
	return result;
}


/**
 * Returns the pixbuf that is used for resize buttons throughout gala at a
 * size of 36px
 *
 * @return the close button pixbuf or null if it failed to load
 */
GdkPixbuf* gala_utils_get_resize_button_pixbuf (void) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* _tmp11_;
	GError * _inner_error_ = NULL;
	_tmp0_ = gala_utils_resize_pixbuf;
	if (_tmp0_ == NULL) {
		gint scale = 0;
		MetaBackend* _tmp1_;
		MetaSettings* _tmp2_;
		gint _tmp3_;
		_tmp1_ = meta_get_backend ();
		_tmp2_ = meta_backend_get_settings (_tmp1_);
		_tmp3_ = meta_settings_get_ui_scaling_factor (_tmp2_);
		scale = _tmp3_;
		{
			GdkPixbuf* _tmp4_ = NULL;
			gint _tmp5_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
			_tmp5_ = scale;
			_tmp6_ = gdk_pixbuf_new_from_resource_at_scale (RESOURCEPATH "/buttons/resize.svg", -1, 36 * _tmp5_, TRUE, &_inner_error_);
			_tmp4_ = _tmp6_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch3_g_error;
			}
			_tmp7_ = _tmp4_;
			_tmp4_ = NULL;
			_g_object_unref0 (gala_utils_resize_pixbuf);
			gala_utils_resize_pixbuf = _tmp7_;
			_g_object_unref0 (_tmp4_);
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp8_ = e;
			_tmp9_ = _tmp8_->message;
			g_warning ("Utils.vala:354: %s", _tmp9_);
			result = NULL;
			_g_error_free0 (e);
			return result;
		}
		__finally3:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp10_ = gala_utils_resize_pixbuf;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	result = _tmp11_;
	return result;
}


/**
 * Creates a new reactive ClutterActor at 36px with the resize pixbuf
 *
 * @return The resize button actor
 */
ClutterActor* gala_utils_create_resize_button (void) {
	ClutterActor* result = NULL;
	ClutterTexture* texture = NULL;
	ClutterTexture* _tmp0_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp1_;
	ClutterTexture* _tmp2_;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
	_tmp0_ = (ClutterTexture*) clutter_texture_new ();
	g_object_ref_sink (_tmp0_);
	texture = _tmp0_;
	_tmp1_ = gala_utils_get_resize_button_pixbuf ();
	pixbuf = _tmp1_;
	_tmp2_ = texture;
	clutter_actor_set_reactive ((ClutterActor*) _tmp2_, TRUE);
	_tmp3_ = pixbuf;
	if (_tmp3_ != NULL) {
		{
			gint _tmp4_ = 0;
			GdkPixbuf* _tmp5_;
			gboolean _tmp6_;
			ClutterTexture* _tmp7_;
			GdkPixbuf* _tmp8_;
			guint8* _tmp9_;
			GdkPixbuf* _tmp10_;
			gboolean _tmp11_;
			GdkPixbuf* _tmp12_;
			gint _tmp13_;
			GdkPixbuf* _tmp14_;
			gint _tmp15_;
			GdkPixbuf* _tmp16_;
			gint _tmp17_;
			_tmp5_ = pixbuf;
			_tmp6_ = gdk_pixbuf_get_has_alpha (_tmp5_);
			if (_tmp6_) {
				_tmp4_ = 4;
			} else {
				_tmp4_ = 3;
			}
			_tmp7_ = texture;
			_tmp8_ = pixbuf;
			_tmp9_ = gdk_pixbuf_get_pixels (_tmp8_);
			_tmp10_ = pixbuf;
			_tmp11_ = gdk_pixbuf_get_has_alpha (_tmp10_);
			_tmp12_ = pixbuf;
			_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
			_tmp14_ = pixbuf;
			_tmp15_ = gdk_pixbuf_get_height (_tmp14_);
			_tmp16_ = pixbuf;
			_tmp17_ = gdk_pixbuf_get_rowstride (_tmp16_);
			clutter_texture_set_from_rgb_data (_tmp7_, _tmp9_, _tmp11_, _tmp13_, _tmp15_, _tmp17_, _tmp4_, 0, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch4_g_error;
			}
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (e);
		}
		__finally4:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (pixbuf);
			_g_object_unref0 (texture);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	} else {
		gint scale = 0;
		MetaBackend* _tmp18_;
		MetaSettings* _tmp19_;
		gint _tmp20_;
		ClutterTexture* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		ClutterTexture* _tmp24_;
		ClutterColor _tmp25_ = {0};
		_tmp18_ = meta_get_backend ();
		_tmp19_ = meta_backend_get_settings (_tmp18_);
		_tmp20_ = meta_settings_get_ui_scaling_factor (_tmp19_);
		scale = _tmp20_;
		_tmp21_ = texture;
		_tmp22_ = scale;
		_tmp23_ = scale;
		clutter_actor_set_size ((ClutterActor*) _tmp21_, (gfloat) (36 * _tmp22_), (gfloat) (36 * _tmp23_));
		_tmp24_ = texture;
		_tmp25_.red = (guint8) 255;
		_tmp25_.green = (guint8) 0;
		_tmp25_.blue = (guint8) 0;
		_tmp25_.alpha = (guint8) 255;
		clutter_actor_set_background_color ((ClutterActor*) _tmp24_, &_tmp25_);
	}
	result = (ClutterActor*) texture;
	_g_object_unref0 (pixbuf);
	return result;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void gala_value_utils_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void gala_value_utils_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		gala_utils_unref (value->data[0].v_pointer);
	}
}


static void gala_value_utils_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gala_utils_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer gala_value_utils_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* gala_value_utils_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GalaUtils * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gala_utils_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* gala_value_utils_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GalaUtils ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gala_utils_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* gala_param_spec_utils (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GalaParamSpecUtils* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GALA_TYPE_UTILS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer gala_value_get_utils (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS), NULL);
	return value->data[0].v_pointer;
}


void gala_value_set_utils (GValue* value, gpointer v_object) {
	GalaUtils * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_UTILS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gala_utils_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gala_utils_unref (old);
	}
}


void gala_value_take_utils (GValue* value, gpointer v_object) {
	GalaUtils * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GALA_TYPE_UTILS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GALA_TYPE_UTILS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gala_utils_unref (old);
	}
}


static void gala_utils_class_init (GalaUtilsClass * klass) {
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	gala_utils_parent_class = g_type_class_peek_parent (klass);
	((GalaUtilsClass *) klass)->finalize = gala_utils_finalize;
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (gala_utils_xid_pixbuf_cache);
	gala_utils_xid_pixbuf_cache = _tmp2_;
	_tmp3_ = g_str_hash;
	_tmp4_ = g_str_equal;
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _g_object_unref0_);
	_g_hash_table_unref0 (gala_utils_icon_pixbuf_cache);
	gala_utils_icon_pixbuf_cache = _tmp5_;
}


static void gala_utils_instance_init (GalaUtils * self) {
	self->ref_count = 1;
}


static void gala_utils_finalize (GalaUtils * obj) {
	GalaUtils * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_UTILS, GalaUtils);
	g_signal_handlers_destroy (self);
}


GType gala_utils_get_type (void) {
	static volatile gsize gala_utils_type_id__volatile = 0;
	if (g_once_init_enter (&gala_utils_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gala_value_utils_init, gala_value_utils_free_value, gala_value_utils_copy_value, gala_value_utils_peek_pointer, "p", gala_value_utils_collect_value, "p", gala_value_utils_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GalaUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaUtils), 0, (GInstanceInitFunc) gala_utils_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gala_utils_type_id;
		gala_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GalaUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gala_utils_type_id__volatile, gala_utils_type_id);
	}
	return gala_utils_type_id__volatile;
}


gpointer gala_utils_ref (gpointer instance) {
	GalaUtils * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void gala_utils_unref (gpointer instance) {
	GalaUtils * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GALA_UTILS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



