/* BackgroundSource.c generated by valac 0.38.10, the Vala compiler
 * generated from BackgroundSource.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <meta/screen.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gsettings-desktop-schemas/gdesktop-enums.h>


#define GALA_TYPE_BACKGROUND_SOURCE (gala_background_source_get_type ())
#define GALA_BACKGROUND_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSource))
#define GALA_BACKGROUND_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSourceClass))
#define GALA_IS_BACKGROUND_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BACKGROUND_SOURCE))
#define GALA_IS_BACKGROUND_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BACKGROUND_SOURCE))
#define GALA_BACKGROUND_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSourceClass))

typedef struct _GalaBackgroundSource GalaBackgroundSource;
typedef struct _GalaBackgroundSourceClass GalaBackgroundSourceClass;
typedef struct _GalaBackgroundSourcePrivate GalaBackgroundSourcePrivate;

#define GALA_TYPE_BACKGROUND (gala_background_get_type ())
#define GALA_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BACKGROUND, GalaBackground))
#define GALA_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BACKGROUND, GalaBackgroundClass))
#define GALA_IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BACKGROUND))
#define GALA_IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BACKGROUND))
#define GALA_BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BACKGROUND, GalaBackgroundClass))

typedef struct _GalaBackground GalaBackground;
typedef struct _GalaBackgroundClass GalaBackgroundClass;

#define GALA_BACKGROUND_SOURCE_TYPE_SETTINGS_HASH_CACHE (gala_background_source_settings_hash_cache_get_type ())
typedef struct _GalaBackgroundSourceSettingsHashCache GalaBackgroundSourceSettingsHashCache;
enum  {
	GALA_BACKGROUND_SOURCE_0_PROPERTY,
	GALA_BACKGROUND_SOURCE_SCREEN_PROPERTY,
	GALA_BACKGROUND_SOURCE_SETTINGS_PROPERTY,
	GALA_BACKGROUND_SOURCE_USE_COUNT_PROPERTY,
	GALA_BACKGROUND_SOURCE_NUM_PROPERTIES
};
static GParamSpec* gala_background_source_properties[GALA_BACKGROUND_SOURCE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	GALA_BACKGROUND_SOURCE_CHANGED_SIGNAL,
	GALA_BACKGROUND_SOURCE_NUM_SIGNALS
};
static guint gala_background_source_signals[GALA_BACKGROUND_SOURCE_NUM_SIGNALS] = {0};

struct _GalaBackgroundSource {
	GObject parent_instance;
	GalaBackgroundSourcePrivate * priv;
};

struct _GalaBackgroundSourceClass {
	GObjectClass parent_class;
};

struct _GalaBackgroundSourceSettingsHashCache {
	guint color_shading_type;
	guint picture_opacity;
	guint picture_options;
	guint picture_uri;
	guint primar_color;
	guint secondary_color;
};

struct _GalaBackgroundSourcePrivate {
	MetaScreen* _screen;
	GSettings* _settings;
	gint _use_count;
	GeeHashMap* backgrounds;
	GalaBackgroundSourceSettingsHashCache settings_hash_cache;
};


static gpointer gala_background_source_parent_class = NULL;

GType gala_background_source_get_type (void) G_GNUC_CONST;
GType gala_background_get_type (void) G_GNUC_CONST;
static GType gala_background_source_settings_hash_cache_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GalaBackgroundSourceSettingsHashCache* gala_background_source_settings_hash_cache_dup (const GalaBackgroundSourceSettingsHashCache* self);
static void gala_background_source_settings_hash_cache_free (GalaBackgroundSourceSettingsHashCache* self);
#define GALA_BACKGROUND_SOURCE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSourcePrivate))
GalaBackgroundSource* gala_background_source_new (MetaScreen* screen, const gchar* settings_schema);
GalaBackgroundSource* gala_background_source_construct (GType object_type, MetaScreen* screen, const gchar* settings_schema);
static void gala_background_source_monitors_changed (GalaBackgroundSource* self);
MetaScreen* gala_background_source_get_screen (GalaBackgroundSource* self);
void gala_background_update_resolution (GalaBackground* self);
static void gala_background_source_background_changed (GalaBackgroundSource* self, GalaBackground* background);
static void _gala_background_source_background_changed_gala_background_changed (GalaBackground* _sender, gpointer self);
void gala_background_destroy (GalaBackground* self);
GalaBackground* gala_background_source_get_background (GalaBackgroundSource* self, gint monitor_index);
GSettings* gala_background_source_get_settings (GalaBackgroundSource* self);
GalaBackground* gala_background_new (MetaScreen* screen, gint monitor_index, const gchar* filename, GalaBackgroundSource* background_source, GDesktopBackgroundStyle style);
GalaBackground* gala_background_construct (GType object_type, MetaScreen* screen, gint monitor_index, const gchar* filename, GalaBackgroundSource* background_source, GDesktopBackgroundStyle style);
gint gala_background_get_monitor_index (GalaBackground* self);
void gala_background_source_destroy (GalaBackgroundSource* self);
static void _gala_background_source_monitors_changed_meta_screen_monitors_changed (MetaScreen* _sender, gpointer self);
static void gala_background_source_settings_changed (GalaBackgroundSource* self, const gchar* key);
static gboolean _vala_string_array_contains (const gchar* * stack, int stack_length, const gchar* needle);
static void gala_background_source_get_current_settings_hash_cache (GalaBackgroundSource* self, GalaBackgroundSourceSettingsHashCache* result);
static void gala_background_source_set_screen (GalaBackgroundSource* self, MetaScreen* value);
static void gala_background_source_set_settings (GalaBackgroundSource* self, GSettings* value);
G_GNUC_INTERNAL gint gala_background_source_get_use_count (GalaBackgroundSource* self);
G_GNUC_INTERNAL void gala_background_source_set_use_count (GalaBackgroundSource* self, gint value);
static GObject * gala_background_source_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _gala_background_source_settings_changed_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
static void gala_background_source_finalize (GObject * obj);
static void _vala_gala_background_source_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_background_source_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);

static const gchar* GALA_BACKGROUND_SOURCE_options[6] = {"color-shading-type", "picture-opacity", "picture-options", "picture-uri", "primary-color", "secondary-color"};

GalaBackgroundSource* gala_background_source_construct (GType object_type, MetaScreen* screen, const gchar* settings_schema) {
	GalaBackgroundSource * self = NULL;
	MetaScreen* _tmp0_;
	const gchar* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	g_return_val_if_fail (screen != NULL, NULL);
	g_return_val_if_fail (settings_schema != NULL, NULL);
	_tmp0_ = screen;
	_tmp1_ = settings_schema;
	_tmp2_ = g_settings_new (_tmp1_);
	_tmp3_ = _tmp2_;
	self = (GalaBackgroundSource*) g_object_new (object_type, "screen", _tmp0_, "settings", _tmp3_, NULL);
	_g_object_unref0 (_tmp3_);
	return self;
}


GalaBackgroundSource* gala_background_source_new (MetaScreen* screen, const gchar* settings_schema) {
	return gala_background_source_construct (GALA_TYPE_BACKGROUND_SOURCE, screen, settings_schema);
}


static void _gala_background_source_background_changed_gala_background_changed (GalaBackground* _sender, gpointer self) {
	gala_background_source_background_changed ((GalaBackgroundSource*) self, _sender);
}


static void gala_background_source_monitors_changed (GalaBackgroundSource* self) {
	gint n = 0;
	MetaScreen* _tmp0_;
	gint _tmp1_;
	gint i = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_screen;
	_tmp1_ = meta_screen_get_n_monitors (_tmp0_);
	n = _tmp1_;
	i = 0;
	{
		GeeIterator* _background_it = NULL;
		GeeHashMap* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
		_tmp2_ = self->priv->backgrounds;
		_tmp3_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = _tmp4_;
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp5_);
		_background_it = _tmp7_;
		while (TRUE) {
			GeeIterator* _tmp8_;
			gboolean _tmp9_;
			GalaBackground* background = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			GalaBackground* _tmp15_;
			guint _tmp16_;
			GalaBackground* _tmp17_;
			GeeHashMap* _tmp18_;
			gint _tmp19_;
			_tmp8_ = _background_it;
			_tmp9_ = gee_iterator_next (_tmp8_);
			if (!_tmp9_) {
				break;
			}
			_tmp10_ = _background_it;
			_tmp11_ = gee_iterator_get (_tmp10_);
			background = (GalaBackground*) _tmp11_;
			_tmp12_ = i;
			i = _tmp12_ + 1;
			_tmp13_ = n;
			if (_tmp12_ < _tmp13_) {
				GalaBackground* _tmp14_;
				_tmp14_ = background;
				gala_background_update_resolution (_tmp14_);
				_g_object_unref0 (background);
				continue;
			}
			_tmp15_ = background;
			g_signal_parse_name ("changed", GALA_TYPE_BACKGROUND, &_tmp16_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (_tmp15_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _gala_background_source_background_changed_gala_background_changed, self);
			_tmp17_ = background;
			gala_background_destroy (_tmp17_);
			_tmp18_ = self->priv->backgrounds;
			_tmp19_ = i;
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) _tmp19_), NULL);
			_g_object_unref0 (background);
		}
		_g_object_unref0 (_background_it);
	}
}


GalaBackground* gala_background_source_get_background (GalaBackgroundSource* self, gint monitor_index) {
	GalaBackground* result = NULL;
	gchar* filename = NULL;
	gint style = 0;
	GSettings* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp16_;
	GeeHashMap* _tmp19_;
	gint _tmp20_;
	gboolean _tmp21_;
	GeeHashMap* _tmp31_;
	gint _tmp32_;
	gpointer _tmp33_;
	g_return_val_if_fail (self != NULL, NULL);
	filename = NULL;
	_tmp0_ = self->priv->_settings;
	_tmp1_ = g_settings_get_enum (_tmp0_, "picture-options");
	style = _tmp1_;
	_tmp2_ = style;
	if (_tmp2_ != ((gint) G_DESKTOP_BACKGROUND_STYLE_NONE)) {
		gchar* uri = NULL;
		GSettings* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_;
		_tmp3_ = self->priv->_settings;
		_tmp4_ = g_settings_get_string (_tmp3_, "picture-uri");
		uri = _tmp4_;
		_tmp5_ = uri;
		_tmp6_ = g_uri_parse_scheme (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp7_ != NULL;
		_g_free0 (_tmp7_);
		if (_tmp8_) {
			const gchar* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			gchar* _tmp12_;
			_tmp9_ = uri;
			_tmp10_ = g_file_new_for_uri (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_file_get_path (_tmp11_);
			_g_free0 (filename);
			filename = _tmp12_;
			_g_object_unref0 (_tmp11_);
		} else {
			const gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp13_ = uri;
			_tmp14_ = g_strdup (_tmp13_);
			_g_free0 (filename);
			filename = _tmp14_;
		}
		_g_free0 (uri);
	}
	_tmp16_ = filename;
	if (_tmp16_ == NULL) {
		_tmp15_ = TRUE;
	} else {
		const gchar* _tmp17_;
		gboolean _tmp18_;
		_tmp17_ = filename;
		_tmp18_ = g_str_has_suffix (_tmp17_, ".xml");
		_tmp15_ = !_tmp18_;
	}
	if (_tmp15_) {
		monitor_index = 0;
	}
	_tmp19_ = self->priv->backgrounds;
	_tmp20_ = monitor_index;
	_tmp21_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp19_, (gpointer) ((gintptr) _tmp20_));
	if (!_tmp21_) {
		GalaBackground* background = NULL;
		MetaScreen* _tmp22_;
		gint _tmp23_;
		const gchar* _tmp24_;
		gint _tmp25_;
		GalaBackground* _tmp26_;
		GalaBackground* _tmp27_;
		GeeHashMap* _tmp28_;
		gint _tmp29_;
		GalaBackground* _tmp30_;
		_tmp22_ = self->priv->_screen;
		_tmp23_ = monitor_index;
		_tmp24_ = filename;
		_tmp25_ = style;
		_tmp26_ = gala_background_new (_tmp22_, _tmp23_, _tmp24_, self, (GDesktopBackgroundStyle) _tmp25_);
		background = _tmp26_;
		_tmp27_ = background;
		g_signal_connect_object (_tmp27_, "changed", (GCallback) _gala_background_source_background_changed_gala_background_changed, self, 0);
		_tmp28_ = self->priv->backgrounds;
		_tmp29_ = monitor_index;
		_tmp30_ = background;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, (gpointer) ((gintptr) _tmp29_), _tmp30_);
		_g_object_unref0 (background);
	}
	_tmp31_ = self->priv->backgrounds;
	_tmp32_ = monitor_index;
	_tmp33_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp31_, (gpointer) ((gintptr) _tmp32_));
	result = (GalaBackground*) _tmp33_;
	_g_free0 (filename);
	return result;
}


static void gala_background_source_background_changed (GalaBackgroundSource* self, GalaBackground* background) {
	GalaBackground* _tmp0_;
	guint _tmp1_;
	GalaBackground* _tmp2_;
	GeeHashMap* _tmp3_;
	GalaBackground* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (background != NULL);
	_tmp0_ = background;
	g_signal_parse_name ("changed", GALA_TYPE_BACKGROUND, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_background_source_background_changed_gala_background_changed, self);
	_tmp2_ = background;
	gala_background_destroy (_tmp2_);
	_tmp3_ = self->priv->backgrounds;
	_tmp4_ = background;
	_tmp5_ = gala_background_get_monitor_index (_tmp4_);
	_tmp6_ = _tmp5_;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) _tmp6_), NULL);
}


static void _gala_background_source_monitors_changed_meta_screen_monitors_changed (MetaScreen* _sender, gpointer self) {
	gala_background_source_monitors_changed ((GalaBackgroundSource*) self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void gala_background_source_destroy (GalaBackgroundSource* self) {
	MetaScreen* _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_screen;
	g_signal_parse_name ("monitors-changed", meta_screen_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_background_source_monitors_changed_meta_screen_monitors_changed, self);
	{
		GeeHashMap* _background_list = NULL;
		GeeHashMap* _tmp2_;
		GeeHashMap* _tmp3_;
		gint _background_size = 0;
		GeeHashMap* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _background_index = 0;
		_tmp2_ = self->priv->backgrounds;
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_background_list = _tmp3_;
		_tmp4_ = _background_list;
		_tmp5_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp4_);
		_tmp6_ = _tmp5_;
		_background_size = _tmp6_;
		_background_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			GalaBackground* background = NULL;
			GeeHashMap* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			GalaBackground* _tmp13_;
			guint _tmp14_;
			GalaBackground* _tmp15_;
			_tmp7_ = _background_index;
			_background_index = _tmp7_ + 1;
			_tmp8_ = _background_index;
			_tmp9_ = _background_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _background_list;
			_tmp11_ = _background_index;
			_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((gintptr) _tmp11_));
			background = (GalaBackground*) _tmp12_;
			_tmp13_ = background;
			g_signal_parse_name ("changed", GALA_TYPE_BACKGROUND, &_tmp14_, NULL, FALSE);
			g_signal_handlers_disconnect_matched (_tmp13_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _gala_background_source_background_changed_gala_background_changed, self);
			_tmp15_ = background;
			gala_background_destroy (_tmp15_);
			_g_object_unref0 (background);
		}
		_g_object_unref0 (_background_list);
	}
}


static gboolean _vala_string_array_contains (const gchar* * stack, int stack_length, const gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static void gala_background_source_settings_changed (GalaBackgroundSource* self, const gchar* key) {
	const gchar* _tmp0_;
	GalaBackgroundSourceSettingsHashCache current = {0};
	GalaBackgroundSourceSettingsHashCache _tmp1_ = {0};
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	if (!_vala_string_array_contains (GALA_BACKGROUND_SOURCE_options, G_N_ELEMENTS (GALA_BACKGROUND_SOURCE_options), _tmp0_)) {
		return;
	}
	gala_background_source_get_current_settings_hash_cache (self, &_tmp1_);
	current = _tmp1_;
	_tmp2_ = memcmp (&self->priv->settings_hash_cache, &current, (gsize) sizeof (GalaBackgroundSourceSettingsHashCache));
	if (_tmp2_ == 0) {
		return;
	}
	memcpy (&self->priv->settings_hash_cache, &current, (gsize) sizeof (GalaBackgroundSourceSettingsHashCache));
	g_signal_emit (self, gala_background_source_signals[GALA_BACKGROUND_SOURCE_CHANGED_SIGNAL], 0);
}


static void gala_background_source_get_current_settings_hash_cache (GalaBackgroundSource* self, GalaBackgroundSourceSettingsHashCache* result) {
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	guint _tmp3_;
	GSettings* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	guint _tmp7_;
	GSettings* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	guint _tmp11_;
	GSettings* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	guint _tmp15_;
	GSettings* _tmp16_;
	GVariant* _tmp17_;
	GVariant* _tmp18_;
	guint _tmp19_;
	GSettings* _tmp20_;
	GVariant* _tmp21_;
	GVariant* _tmp22_;
	guint _tmp23_;
	GalaBackgroundSourceSettingsHashCache _tmp24_ = {0};
	GalaBackgroundSourceSettingsHashCache _tmp25_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "color-shading-type");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_hash (_tmp2_);
	_tmp4_ = self->priv->_settings;
	_tmp5_ = g_settings_get_value (_tmp4_, "picture-opacity");
	_tmp6_ = _tmp5_;
	_tmp7_ = g_variant_hash (_tmp6_);
	_tmp8_ = self->priv->_settings;
	_tmp9_ = g_settings_get_value (_tmp8_, "picture-options");
	_tmp10_ = _tmp9_;
	_tmp11_ = g_variant_hash (_tmp10_);
	_tmp12_ = self->priv->_settings;
	_tmp13_ = g_settings_get_value (_tmp12_, "picture-uri");
	_tmp14_ = _tmp13_;
	_tmp15_ = g_variant_hash (_tmp14_);
	_tmp16_ = self->priv->_settings;
	_tmp17_ = g_settings_get_value (_tmp16_, "primary-color");
	_tmp18_ = _tmp17_;
	_tmp19_ = g_variant_hash (_tmp18_);
	_tmp20_ = self->priv->_settings;
	_tmp21_ = g_settings_get_value (_tmp20_, "secondary-color");
	_tmp22_ = _tmp21_;
	_tmp23_ = g_variant_hash (_tmp22_);
	_tmp24_.color_shading_type = _tmp3_;
	_tmp24_.picture_opacity = _tmp7_;
	_tmp24_.picture_options = _tmp11_;
	_tmp24_.picture_uri = _tmp15_;
	_tmp24_.primar_color = _tmp19_;
	_tmp24_.secondary_color = _tmp23_;
	_tmp25_ = _tmp24_;
	_g_variant_unref0 (_tmp22_);
	_g_variant_unref0 (_tmp18_);
	_g_variant_unref0 (_tmp14_);
	_g_variant_unref0 (_tmp10_);
	_g_variant_unref0 (_tmp6_);
	_g_variant_unref0 (_tmp2_);
	*result = _tmp25_;
	return;
}


MetaScreen* gala_background_source_get_screen (GalaBackgroundSource* self) {
	MetaScreen* result;
	MetaScreen* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_screen;
	result = _tmp0_;
	return result;
}


static void gala_background_source_set_screen (GalaBackgroundSource* self, MetaScreen* value) {
	g_return_if_fail (self != NULL);
	if (gala_background_source_get_screen (self) != value) {
		MetaScreen* _tmp0_;
		MetaScreen* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_screen);
		self->priv->_screen = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, gala_background_source_properties[GALA_BACKGROUND_SOURCE_SCREEN_PROPERTY]);
	}
}


GSettings* gala_background_source_get_settings (GalaBackgroundSource* self) {
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_settings;
	result = _tmp0_;
	return result;
}


static void gala_background_source_set_settings (GalaBackgroundSource* self, GSettings* value) {
	g_return_if_fail (self != NULL);
	if (gala_background_source_get_settings (self) != value) {
		GSettings* _tmp0_;
		GSettings* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_settings);
		self->priv->_settings = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, gala_background_source_properties[GALA_BACKGROUND_SOURCE_SETTINGS_PROPERTY]);
	}
}


G_GNUC_INTERNAL gint gala_background_source_get_use_count (GalaBackgroundSource* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_use_count;
	result = _tmp0_;
	return result;
}


G_GNUC_INTERNAL void gala_background_source_set_use_count (GalaBackgroundSource* self, gint value) {
	g_return_if_fail (self != NULL);
	if (gala_background_source_get_use_count (self) != value) {
		gint _tmp0_;
		_tmp0_ = value;
		self->priv->_use_count = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_background_source_properties[GALA_BACKGROUND_SOURCE_USE_COUNT_PROPERTY]);
	}
}


static void _gala_background_source_settings_changed_g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	gala_background_source_settings_changed ((GalaBackgroundSource*) self, key);
}


static GObject * gala_background_source_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GalaBackgroundSource * self;
	GeeHashMap* _tmp0_;
	MetaScreen* _tmp1_;
	GalaBackgroundSourceSettingsHashCache _tmp2_ = {0};
	GSettings* _tmp3_;
	parent_class = G_OBJECT_CLASS (gala_background_source_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSource);
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, GALA_TYPE_BACKGROUND, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->backgrounds);
	self->priv->backgrounds = _tmp0_;
	_tmp1_ = self->priv->_screen;
	g_signal_connect_object (_tmp1_, "monitors-changed", (GCallback) _gala_background_source_monitors_changed_meta_screen_monitors_changed, self, 0);
	gala_background_source_get_current_settings_hash_cache (self, &_tmp2_);
	self->priv->settings_hash_cache = _tmp2_;
	_tmp3_ = self->priv->_settings;
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _gala_background_source_settings_changed_g_settings_changed, self, 0);
	return obj;
}


static GalaBackgroundSourceSettingsHashCache* gala_background_source_settings_hash_cache_dup (const GalaBackgroundSourceSettingsHashCache* self) {
	GalaBackgroundSourceSettingsHashCache* dup;
	dup = g_new0 (GalaBackgroundSourceSettingsHashCache, 1);
	memcpy (dup, self, sizeof (GalaBackgroundSourceSettingsHashCache));
	return dup;
}


static void gala_background_source_settings_hash_cache_free (GalaBackgroundSourceSettingsHashCache* self) {
	g_free (self);
}


static GType gala_background_source_settings_hash_cache_get_type (void) {
	static volatile gsize gala_background_source_settings_hash_cache_type_id__volatile = 0;
	if (g_once_init_enter (&gala_background_source_settings_hash_cache_type_id__volatile)) {
		GType gala_background_source_settings_hash_cache_type_id;
		gala_background_source_settings_hash_cache_type_id = g_boxed_type_register_static ("GalaBackgroundSourceSettingsHashCache", (GBoxedCopyFunc) gala_background_source_settings_hash_cache_dup, (GBoxedFreeFunc) gala_background_source_settings_hash_cache_free);
		g_once_init_leave (&gala_background_source_settings_hash_cache_type_id__volatile, gala_background_source_settings_hash_cache_type_id);
	}
	return gala_background_source_settings_hash_cache_type_id__volatile;
}


static void gala_background_source_class_init (GalaBackgroundSourceClass * klass) {
	gala_background_source_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GalaBackgroundSourcePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_background_source_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_background_source_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_background_source_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_background_source_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BACKGROUND_SOURCE_SCREEN_PROPERTY, gala_background_source_properties[GALA_BACKGROUND_SOURCE_SCREEN_PROPERTY] = g_param_spec_object ("screen", "screen", "screen", meta_screen_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BACKGROUND_SOURCE_SETTINGS_PROPERTY, gala_background_source_properties[GALA_BACKGROUND_SOURCE_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_BACKGROUND_SOURCE_USE_COUNT_PROPERTY, gala_background_source_properties[GALA_BACKGROUND_SOURCE_USE_COUNT_PROPERTY] = g_param_spec_int ("use-count", "use-count", "use-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gala_background_source_signals[GALA_BACKGROUND_SOURCE_CHANGED_SIGNAL] = g_signal_new ("changed", GALA_TYPE_BACKGROUND_SOURCE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void gala_background_source_instance_init (GalaBackgroundSource * self) {
	self->priv = GALA_BACKGROUND_SOURCE_GET_PRIVATE (self);
	self->priv->_use_count = 0;
}


static void gala_background_source_finalize (GObject * obj) {
	GalaBackgroundSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSource);
	_g_object_unref0 (self->priv->_screen);
	_g_object_unref0 (self->priv->_settings);
	_g_object_unref0 (self->priv->backgrounds);
	G_OBJECT_CLASS (gala_background_source_parent_class)->finalize (obj);
}


GType gala_background_source_get_type (void) {
	static volatile gsize gala_background_source_type_id__volatile = 0;
	if (g_once_init_enter (&gala_background_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaBackgroundSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_background_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaBackgroundSource), 0, (GInstanceInitFunc) gala_background_source_instance_init, NULL };
		GType gala_background_source_type_id;
		gala_background_source_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaBackgroundSource", &g_define_type_info, 0);
		g_once_init_leave (&gala_background_source_type_id__volatile, gala_background_source_type_id);
	}
	return gala_background_source_type_id__volatile;
}


static void _vala_gala_background_source_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaBackgroundSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSource);
	switch (property_id) {
		case GALA_BACKGROUND_SOURCE_SCREEN_PROPERTY:
		g_value_set_object (value, gala_background_source_get_screen (self));
		break;
		case GALA_BACKGROUND_SOURCE_SETTINGS_PROPERTY:
		g_value_set_object (value, gala_background_source_get_settings (self));
		break;
		case GALA_BACKGROUND_SOURCE_USE_COUNT_PROPERTY:
		g_value_set_int (value, gala_background_source_get_use_count (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gala_background_source_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaBackgroundSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_BACKGROUND_SOURCE, GalaBackgroundSource);
	switch (property_id) {
		case GALA_BACKGROUND_SOURCE_SCREEN_PROPERTY:
		gala_background_source_set_screen (self, g_value_get_object (value));
		break;
		case GALA_BACKGROUND_SOURCE_SETTINGS_PROPERTY:
		gala_background_source_set_settings (self, g_value_get_object (value));
		break;
		case GALA_BACKGROUND_SOURCE_USE_COUNT_PROPERTY:
		gala_background_source_set_use_count (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



