/* DragDropAction.c generated by valac 0.38.10, the Vala compiler
 * generated from DragDropAction.vala, do not modify */

/**/
/*  Copyright (C) 2013 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gee.h>


#define GALA_TYPE_DRAG_DROP_ACTION_TYPE (gala_drag_drop_action_type_get_type ())

#define GALA_TYPE_DRAG_DROP_ACTION (gala_drag_drop_action_get_type ())
#define GALA_DRAG_DROP_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction))
#define GALA_DRAG_DROP_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionClass))
#define GALA_IS_DRAG_DROP_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DRAG_DROP_ACTION))
#define GALA_IS_DRAG_DROP_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DRAG_DROP_ACTION))
#define GALA_DRAG_DROP_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionClass))

typedef struct _GalaDragDropAction GalaDragDropAction;
typedef struct _GalaDragDropActionClass GalaDragDropActionClass;
typedef struct _GalaDragDropActionPrivate GalaDragDropActionPrivate;
enum  {
	GALA_DRAG_DROP_ACTION_0_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY,
	GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY,
	GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY,
	GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY,
	GALA_DRAG_DROP_ACTION_NUM_PROPERTIES
};
static GParamSpec* gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
enum  {
	GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL,
	GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL,
	GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL,
	GALA_DRAG_DROP_ACTION_NUM_SIGNALS
};
static guint gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_NUM_SIGNALS] = {0};

typedef enum  {
	GALA_DRAG_DROP_ACTION_TYPE_SOURCE = 0,
	GALA_DRAG_DROP_ACTION_TYPE_DESTINATION
} GalaDragDropActionType;

struct _GalaDragDropAction {
	ClutterAction parent_instance;
	GalaDragDropActionPrivate * priv;
};

struct _GalaDragDropActionClass {
	ClutterActionClass parent_class;
};

struct _GalaDragDropActionPrivate {
	GalaDragDropActionType _drag_type;
	gchar* _drag_id;
	ClutterActor* _handle;
	gboolean _dragging;
	gboolean _allow_bubbling;
	ClutterActor* hovered;
	gboolean clicked;
	gfloat last_x;
	gfloat last_y;
};


static gpointer gala_drag_drop_action_parent_class = NULL;
static GeeHashMap* gala_drag_drop_action_sources;
static GeeHashMap* gala_drag_drop_action_sources = NULL;

GType gala_drag_drop_action_type_get_type (void) G_GNUC_CONST;
GType gala_drag_drop_action_get_type (void) G_GNUC_CONST;
#define GALA_DRAG_DROP_ACTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropActionPrivate))
static void gala_drag_drop_action_release_actor (GalaDragDropAction* self, ClutterActor* actor);
GalaDragDropAction* gala_drag_drop_action_new (GalaDragDropActionType type, const gchar* id);
GalaDragDropAction* gala_drag_drop_action_construct (GType object_type, GalaDragDropActionType type, const gchar* id);
static void gala_drag_drop_action_real_set_actor (ClutterActorMeta* base, ClutterActor* new_actor);
static void gala_drag_drop_action_connect_actor (GalaDragDropAction* self, ClutterActor* actor);
GalaDragDropActionType gala_drag_drop_action_get_drag_type (GalaDragDropAction* self);
static gboolean gala_drag_drop_action_source_clicked (GalaDragDropAction* self, ClutterButtonEvent* event);
static gboolean _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event (ClutterActor* _sender, ClutterButtonEvent* event, gpointer self);
const gchar* gala_drag_drop_action_get_drag_id (GalaDragDropAction* self);
static void gala_drag_drop_action_emit_crossed (GalaDragDropAction* self, ClutterActor* destination, gboolean hovered);
static GalaDragDropAction* gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self, ClutterActor* actor);
static gboolean gala_drag_drop_action_follow_move (GalaDragDropAction* self, ClutterEvent* event);
static gboolean _gala_drag_drop_action_follow_move_clutter_actor_captured_event (ClutterActor* _sender, ClutterEvent* event, gpointer self);
gboolean gala_drag_drop_action_get_dragging (GalaDragDropAction* self);
static void gala_drag_drop_action_set_handle (GalaDragDropAction* self, ClutterActor* value);
ClutterActor* gala_drag_drop_action_get_handle (GalaDragDropAction* self);
static void gala_drag_drop_action_set_dragging (GalaDragDropAction* self, gboolean value);
void gala_drag_drop_action_cancel (GalaDragDropAction* self);
gboolean gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self);
static void gala_drag_drop_action_finish (GalaDragDropAction* self);
static void gala_drag_drop_action_cleanup (GalaDragDropAction* self);
void gala_drag_drop_action_cancel_all_by_id (const gchar* id);
static void gala_drag_drop_action_set_drag_type (GalaDragDropAction* self, GalaDragDropActionType value);
static void gala_drag_drop_action_set_drag_id (GalaDragDropAction* self, const gchar* value);
void gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self, gboolean value);
static void g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void gala_drag_drop_action_finalize (GObject * obj);
static void _vala_gala_drag_drop_action_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_drag_drop_action_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType gala_drag_drop_action_type_get_type (void) {
	static volatile gsize gala_drag_drop_action_type_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GALA_DRAG_DROP_ACTION_TYPE_SOURCE, "GALA_DRAG_DROP_ACTION_TYPE_SOURCE", "source"}, {GALA_DRAG_DROP_ACTION_TYPE_DESTINATION, "GALA_DRAG_DROP_ACTION_TYPE_DESTINATION", "destination"}, {0, NULL, NULL}};
		GType gala_drag_drop_action_type_type_id;
		gala_drag_drop_action_type_type_id = g_enum_register_static ("GalaDragDropActionType", values);
		g_once_init_leave (&gala_drag_drop_action_type_type_id__volatile, gala_drag_drop_action_type_type_id);
	}
	return gala_drag_drop_action_type_type_id__volatile;
}


/**
 * Create a new DragDropAction
 *
 * @param type The type of this actor
 * @param id   An ID that marks which sources can be dragged on
 *             which destinations. It has to be the same for all actors that
 *             should be compatible with each other.
 */
GalaDragDropAction* gala_drag_drop_action_construct (GType object_type, GalaDragDropActionType type, const gchar* id) {
	GalaDragDropAction * self = NULL;
	GalaDragDropActionType _tmp0_;
	const gchar* _tmp1_;
	GeeHashMap* _tmp2_;
	g_return_val_if_fail (id != NULL, NULL);
	_tmp0_ = type;
	_tmp1_ = id;
	self = (GalaDragDropAction*) g_object_new (object_type, "drag-type", _tmp0_, "drag-id", _tmp1_, NULL);
	_tmp2_ = gala_drag_drop_action_sources;
	if (_tmp2_ == NULL) {
		GeeHashMap* _tmp3_;
		_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LINKED_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		_g_object_unref0 (gala_drag_drop_action_sources);
		gala_drag_drop_action_sources = _tmp3_;
	}
	return self;
}


GalaDragDropAction* gala_drag_drop_action_new (GalaDragDropActionType type, const gchar* id) {
	return gala_drag_drop_action_construct (GALA_TYPE_DRAG_DROP_ACTION, type, id);
}


static void gala_drag_drop_action_real_set_actor (ClutterActorMeta* base, ClutterActor* new_actor) {
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp6_;
	self = (GalaDragDropAction*) base;
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
		_tmp3_ = _tmp2_;
		gala_drag_drop_action_release_actor (self, _tmp3_);
	}
	_tmp4_ = new_actor;
	if (_tmp4_ != NULL) {
		ClutterActor* _tmp5_;
		_tmp5_ = new_actor;
		gala_drag_drop_action_connect_actor (self, _tmp5_);
	}
	_tmp6_ = new_actor;
	CLUTTER_ACTOR_META_CLASS (gala_drag_drop_action_parent_class)->set_actor ((ClutterActorMeta*) G_TYPE_CHECK_INSTANCE_CAST (self, clutter_action_get_type (), ClutterAction), _tmp6_);
}


static gboolean _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event (ClutterActor* _sender, ClutterButtonEvent* event, gpointer self) {
	gboolean result;
	result = gala_drag_drop_action_source_clicked ((GalaDragDropAction*) self, event);
	return result;
}


static void gala_drag_drop_action_release_actor (GalaDragDropAction* self, ClutterActor* actor) {
	GalaDragDropActionType _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (actor != NULL);
	_tmp0_ = self->priv->_drag_type;
	if (_tmp0_ == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
		ClutterActor* _tmp1_;
		guint _tmp2_;
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp3_;
		const gchar* _tmp4_;
		gpointer _tmp5_;
		GeeLinkedList* _tmp6_;
		ClutterActor* _tmp7_;
		_tmp1_ = actor;
		g_signal_parse_name ("button-press-event", clutter_actor_get_type (), &_tmp2_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event, self);
		_tmp3_ = gala_drag_drop_action_sources;
		_tmp4_ = self->priv->_drag_id;
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, _tmp4_);
		source_list = (GeeLinkedList*) _tmp5_;
		_tmp6_ = source_list;
		_tmp7_ = actor;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, _tmp7_);
		_g_object_unref0 (source_list);
	}
}


static void gala_drag_drop_action_connect_actor (GalaDragDropAction* self, ClutterActor* actor) {
	GalaDragDropActionType _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (actor != NULL);
	_tmp0_ = self->priv->_drag_type;
	if (_tmp0_ == GALA_DRAG_DROP_ACTION_TYPE_SOURCE) {
		ClutterActor* _tmp1_;
		GeeLinkedList* source_list = NULL;
		GeeHashMap* _tmp2_;
		const gchar* _tmp3_;
		gpointer _tmp4_;
		GeeLinkedList* _tmp5_;
		GeeLinkedList* _tmp10_;
		ClutterActor* _tmp11_;
		_tmp1_ = actor;
		g_signal_connect_object (_tmp1_, "button-press-event", (GCallback) _gala_drag_drop_action_source_clicked_clutter_actor_button_press_event, self, 0);
		_tmp2_ = gala_drag_drop_action_sources;
		_tmp3_ = self->priv->_drag_id;
		_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp3_);
		source_list = (GeeLinkedList*) _tmp4_;
		_tmp5_ = source_list;
		if (_tmp5_ == NULL) {
			GeeLinkedList* _tmp6_;
			GeeHashMap* _tmp7_;
			const gchar* _tmp8_;
			GeeLinkedList* _tmp9_;
			_tmp6_ = gee_linked_list_new (clutter_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
			_g_object_unref0 (source_list);
			source_list = _tmp6_;
			_tmp7_ = gala_drag_drop_action_sources;
			_tmp8_ = self->priv->_drag_id;
			_tmp9_ = source_list;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, _tmp8_, _tmp9_);
		}
		_tmp10_ = source_list;
		_tmp11_ = actor;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
		_g_object_unref0 (source_list);
	}
}


static void gala_drag_drop_action_emit_crossed (GalaDragDropAction* self, ClutterActor* destination, gboolean hovered) {
	ClutterActor* _tmp0_;
	GalaDragDropAction* _tmp1_;
	GalaDragDropAction* _tmp2_;
	gboolean _tmp3_;
	ClutterActor* _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (destination != NULL);
	_tmp0_ = destination;
	_tmp1_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = hovered;
	g_signal_emit (_tmp2_, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL], 0, _tmp3_);
	_g_object_unref0 (_tmp2_);
	_tmp4_ = destination;
	_tmp5_ = hovered;
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL], 0, _tmp4_, _tmp5_);
}


static gboolean _gala_drag_drop_action_follow_move_clutter_actor_captured_event (ClutterActor* _sender, ClutterEvent* event, gpointer self) {
	gboolean result;
	result = gala_drag_drop_action_follow_move ((GalaDragDropAction*) self, event);
	return result;
}


static gboolean gala_drag_drop_action_source_clicked (GalaDragDropAction* self, ClutterButtonEvent* event) {
	gboolean result = FALSE;
	ClutterButtonEvent* _tmp0_;
	guint32 _tmp1_;
	ClutterActor* _tmp4_;
	ClutterActor* _tmp5_;
	ClutterStage* _tmp6_;
	ClutterButtonEvent* _tmp7_;
	gfloat _tmp8_;
	ClutterButtonEvent* _tmp9_;
	gfloat _tmp10_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = _tmp0_->button;
	if (_tmp1_ != ((guint32) 1)) {
		ClutterButtonEvent* _tmp2_;
		guint32 _tmp3_;
		_tmp2_ = event;
		_tmp3_ = _tmp2_->button;
		g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, _tmp3_);
		result = FALSE;
		return result;
	}
	_tmp4_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = clutter_actor_get_stage (_tmp5_);
	g_signal_connect_object ((ClutterActor*) _tmp6_, "captured-event", (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self, 0);
	self->priv->clicked = TRUE;
	_tmp7_ = event;
	_tmp8_ = _tmp7_->x;
	self->priv->last_x = _tmp8_;
	_tmp9_ = event;
	_tmp10_ = _tmp9_->y;
	self->priv->last_y = _tmp10_;
	result = TRUE;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean gala_drag_drop_action_follow_move (GalaDragDropAction* self, ClutterEvent* event) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	ClutterEvent* _tmp76_;
	ClutterEventType _tmp77_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_dragging;
	if (!_tmp0_) {
		ClutterEvent* _tmp1_;
		ClutterEventType _tmp2_;
		_tmp1_ = event;
		_tmp2_ = clutter_event_type (_tmp1_);
		switch (_tmp2_) {
			case CLUTTER_MOTION:
			{
				gfloat x = 0.0F;
				gfloat y = 0.0F;
				ClutterEvent* _tmp3_;
				gfloat _tmp4_ = 0.0F;
				gfloat _tmp5_ = 0.0F;
				gint drag_threshold = 0;
				ClutterSettings* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gboolean _tmp9_ = FALSE;
				gfloat _tmp10_;
				gfloat _tmp11_;
				gfloat _tmp12_;
				gint _tmp13_;
				_tmp3_ = event;
				clutter_event_get_coords (_tmp3_, &_tmp4_, &_tmp5_);
				x = _tmp4_;
				y = _tmp5_;
				_tmp6_ = clutter_settings_get_default ();
				g_object_get (_tmp6_, "dnd-drag-threshold", &_tmp7_, NULL);
				_tmp8_ = _tmp7_;
				drag_threshold = _tmp8_;
				_tmp10_ = self->priv->last_x;
				_tmp11_ = x;
				_tmp12_ = fabsf (_tmp10_ - _tmp11_);
				_tmp13_ = drag_threshold;
				if (_tmp12_ > ((gfloat) _tmp13_)) {
					_tmp9_ = TRUE;
				} else {
					gfloat _tmp14_;
					gfloat _tmp15_;
					gfloat _tmp16_;
					gint _tmp17_;
					_tmp14_ = self->priv->last_y;
					_tmp15_ = y;
					_tmp16_ = fabsf (_tmp14_ - _tmp15_);
					_tmp17_ = drag_threshold;
					_tmp9_ = _tmp16_ > ((gfloat) _tmp17_);
				}
				if (_tmp9_) {
					gfloat _tmp18_;
					gfloat _tmp19_;
					ClutterActor* _tmp20_ = NULL;
					ClutterActor* _tmp21_;
					ClutterActor* _tmp22_;
					ClutterActor* _tmp27_;
					GeeLinkedList* source_list = NULL;
					GeeHashMap* _tmp28_;
					const gchar* _tmp29_;
					gpointer _tmp30_;
					GeeLinkedList* _tmp31_;
					_tmp18_ = x;
					_tmp19_ = y;
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL], 0, _tmp18_, _tmp19_, &_tmp20_);
					_tmp21_ = _tmp20_;
					gala_drag_drop_action_set_handle (self, _tmp21_);
					_g_object_unref0 (_tmp21_);
					_tmp22_ = self->priv->_handle;
					if (_tmp22_ == NULL) {
						ClutterActor* _tmp23_;
						ClutterActor* _tmp24_;
						ClutterStage* _tmp25_;
						guint _tmp26_;
						_tmp23_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
						_tmp24_ = _tmp23_;
						_tmp25_ = clutter_actor_get_stage (_tmp24_);
						g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp26_, NULL, FALSE);
						g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp25_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp26_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
						g_critical ("DragDropAction.vala:200: No handle has been returned by the started si" \
"gnal, aborting drag.");
						result = FALSE;
						return result;
					}
					_tmp27_ = self->priv->_handle;
					clutter_actor_set_reactive (_tmp27_, FALSE);
					self->priv->clicked = FALSE;
					gala_drag_drop_action_set_dragging (self, TRUE);
					_tmp28_ = gala_drag_drop_action_sources;
					_tmp29_ = self->priv->_drag_id;
					_tmp30_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp28_, _tmp29_);
					source_list = (GeeLinkedList*) _tmp30_;
					_tmp31_ = source_list;
					if (_tmp31_ != NULL) {
						{
							GeeLinkedList* _actor_list = NULL;
							GeeLinkedList* _tmp32_;
							GeeLinkedList* _tmp33_;
							gint _actor_size = 0;
							GeeLinkedList* _tmp34_;
							gint _tmp35_;
							gint _tmp36_;
							gint _actor_index = 0;
							_tmp32_ = source_list;
							_tmp33_ = _g_object_ref0 (_tmp32_);
							_actor_list = _tmp33_;
							_tmp34_ = _actor_list;
							_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
							_tmp36_ = _tmp35_;
							_actor_size = _tmp36_;
							_actor_index = -1;
							while (TRUE) {
								gint _tmp37_;
								gint _tmp38_;
								gint _tmp39_;
								ClutterActor* actor = NULL;
								GeeLinkedList* _tmp40_;
								gint _tmp41_;
								gpointer _tmp42_;
								ClutterActor* _tmp43_;
								_tmp37_ = _actor_index;
								_actor_index = _tmp37_ + 1;
								_tmp38_ = _actor_index;
								_tmp39_ = _actor_size;
								if (!(_tmp38_ < _tmp39_)) {
									break;
								}
								_tmp40_ = _actor_list;
								_tmp41_ = _actor_index;
								_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp40_, _tmp41_);
								actor = (ClutterActor*) _tmp42_;
								_tmp43_ = actor;
								clutter_actor_set_reactive (_tmp43_, FALSE);
								_g_object_unref0 (actor);
							}
							_g_object_unref0 (_actor_list);
						}
					}
					_g_object_unref0 (source_list);
				}
				result = TRUE;
				return result;
			}
			case CLUTTER_BUTTON_RELEASE:
			{
				gfloat x = 0.0F;
				gfloat y = 0.0F;
				gfloat ex = 0.0F;
				gfloat ey = 0.0F;
				ClutterEvent* _tmp44_;
				gfloat _tmp45_ = 0.0F;
				gfloat _tmp46_ = 0.0F;
				ClutterActor* _tmp47_;
				ClutterActor* _tmp48_;
				gfloat _tmp49_ = 0.0F;
				gfloat _tmp50_ = 0.0F;
				gboolean _tmp51_ = FALSE;
				gboolean _tmp52_ = FALSE;
				gboolean _tmp53_ = FALSE;
				gfloat _tmp54_;
				gfloat _tmp55_;
				ClutterActor* _tmp72_;
				ClutterActor* _tmp73_;
				ClutterStage* _tmp74_;
				guint _tmp75_;
				_tmp44_ = event;
				clutter_event_get_coords (_tmp44_, &_tmp45_, &_tmp46_);
				ex = _tmp45_;
				ey = _tmp46_;
				_tmp47_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
				_tmp48_ = _tmp47_;
				clutter_actor_get_transformed_position (_tmp48_, &_tmp49_, &_tmp50_);
				x = _tmp49_;
				y = _tmp50_;
				_tmp54_ = x;
				_tmp55_ = ex;
				if (_tmp54_ < _tmp55_) {
					gfloat _tmp56_;
					ClutterActor* _tmp57_;
					ClutterActor* _tmp58_;
					gfloat _tmp59_;
					gfloat _tmp60_;
					gfloat _tmp61_;
					_tmp56_ = x;
					_tmp57_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
					_tmp58_ = _tmp57_;
					_tmp59_ = clutter_actor_get_width (_tmp58_);
					_tmp60_ = _tmp59_;
					_tmp61_ = ex;
					_tmp53_ = (_tmp56_ + _tmp60_) > _tmp61_;
				} else {
					_tmp53_ = FALSE;
				}
				if (_tmp53_) {
					gfloat _tmp62_;
					gfloat _tmp63_;
					_tmp62_ = y;
					_tmp63_ = ey;
					_tmp52_ = _tmp62_ < _tmp63_;
				} else {
					_tmp52_ = FALSE;
				}
				if (_tmp52_) {
					gfloat _tmp64_;
					ClutterActor* _tmp65_;
					ClutterActor* _tmp66_;
					gfloat _tmp67_;
					gfloat _tmp68_;
					gfloat _tmp69_;
					_tmp64_ = y;
					_tmp65_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
					_tmp66_ = _tmp65_;
					_tmp67_ = clutter_actor_get_height (_tmp66_);
					_tmp68_ = _tmp67_;
					_tmp69_ = ey;
					_tmp51_ = (_tmp64_ + _tmp68_) > _tmp69_;
				} else {
					_tmp51_ = FALSE;
				}
				if (_tmp51_) {
					ClutterEvent* _tmp70_;
					guint32 _tmp71_;
					_tmp70_ = event;
					_tmp71_ = clutter_event_get_button (_tmp70_);
					g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL], 0, _tmp71_);
				}
				_tmp72_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
				_tmp73_ = _tmp72_;
				_tmp74_ = clutter_actor_get_stage (_tmp73_);
				g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp75_, NULL, FALSE);
				g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp74_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp75_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
				self->priv->clicked = FALSE;
				gala_drag_drop_action_set_dragging (self, FALSE);
				result = TRUE;
				return result;
			}
			default:
			{
				result = TRUE;
				return result;
			}
		}
	}
	_tmp76_ = event;
	_tmp77_ = clutter_event_type (_tmp76_);
	switch (_tmp77_) {
		case CLUTTER_KEY_PRESS:
		{
			ClutterEvent* _tmp78_;
			guint16 _tmp79_;
			_tmp78_ = event;
			_tmp79_ = clutter_event_get_key_code (_tmp78_);
			if (((gint) _tmp79_) == CLUTTER_KEY_Escape) {
				gala_drag_drop_action_cancel (self);
			}
			result = TRUE;
			return result;
		}
		case CLUTTER_MOTION:
		{
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			ClutterEvent* _tmp80_;
			gfloat _tmp81_ = 0.0F;
			gfloat _tmp82_ = 0.0F;
			ClutterActor* _tmp83_;
			ClutterActor* _tmp84_;
			gfloat _tmp85_;
			gfloat _tmp86_;
			gfloat _tmp87_;
			gfloat _tmp88_;
			ClutterActor* _tmp89_;
			ClutterActor* _tmp90_;
			gfloat _tmp91_;
			gfloat _tmp92_;
			gfloat _tmp93_;
			gfloat _tmp94_;
			gfloat _tmp95_;
			gfloat _tmp96_;
			ClutterStage* stage = NULL;
			ClutterActor* _tmp97_;
			ClutterActor* _tmp98_;
			ClutterStage* _tmp99_;
			ClutterStage* _tmp100_;
			ClutterActor* actor = NULL;
			ClutterStage* _tmp101_;
			gfloat _tmp102_;
			gfloat _tmp103_;
			ClutterActor* _tmp104_;
			ClutterActor* _tmp105_;
			GalaDragDropAction* action = NULL;
			gboolean _tmp106_ = FALSE;
			gboolean _tmp107_ = FALSE;
			ClutterActor* _tmp108_;
			ClutterActor* _tmp121_;
			ClutterActor* _tmp122_;
			GalaDragDropAction* _tmp123_;
			ClutterActor* _tmp126_;
			ClutterActor* _tmp128_;
			ClutterActor* _tmp129_;
			ClutterActor* _tmp130_;
			_tmp80_ = event;
			clutter_event_get_coords (_tmp80_, &_tmp81_, &_tmp82_);
			x = _tmp81_;
			y = _tmp82_;
			_tmp83_ = self->priv->_handle;
			_tmp84_ = self->priv->_handle;
			_tmp85_ = clutter_actor_get_x (_tmp84_);
			_tmp86_ = _tmp85_;
			_tmp87_ = self->priv->last_x;
			_tmp88_ = x;
			clutter_actor_set_x (_tmp84_, _tmp86_ - (_tmp87_ - _tmp88_));
			_tmp89_ = self->priv->_handle;
			_tmp90_ = self->priv->_handle;
			_tmp91_ = clutter_actor_get_y (_tmp90_);
			_tmp92_ = _tmp91_;
			_tmp93_ = self->priv->last_y;
			_tmp94_ = y;
			clutter_actor_set_y (_tmp90_, _tmp92_ - (_tmp93_ - _tmp94_));
			_tmp95_ = x;
			self->priv->last_x = _tmp95_;
			_tmp96_ = y;
			self->priv->last_y = _tmp96_;
			_tmp97_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
			_tmp98_ = _tmp97_;
			_tmp99_ = clutter_actor_get_stage (_tmp98_);
			_tmp100_ = _g_object_ref0 (_tmp99_);
			stage = _tmp100_;
			_tmp101_ = stage;
			_tmp102_ = x;
			_tmp103_ = y;
			_tmp104_ = clutter_stage_get_actor_at_pos (_tmp101_, CLUTTER_PICK_REACTIVE, (gint) _tmp102_, (gint) _tmp103_);
			_tmp105_ = _g_object_ref0 (_tmp104_);
			actor = _tmp105_;
			action = NULL;
			_tmp108_ = actor;
			if (_tmp108_ != NULL) {
				ClutterActor* _tmp109_;
				GalaDragDropAction* _tmp110_;
				GalaDragDropAction* _tmp111_;
				_tmp109_ = actor;
				_tmp110_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp109_);
				_g_object_unref0 (action);
				action = _tmp110_;
				_tmp111_ = action;
				_tmp107_ = _tmp111_ == NULL;
			} else {
				_tmp107_ = FALSE;
			}
			if (_tmp107_) {
				gboolean _tmp112_;
				_tmp112_ = self->priv->_allow_bubbling;
				_tmp106_ = _tmp112_;
			} else {
				_tmp106_ = FALSE;
			}
			if (_tmp106_) {
				while (TRUE) {
					ClutterActor* _tmp113_;
					ClutterActor* _tmp114_;
					ClutterActor* _tmp115_;
					ClutterActor* _tmp116_;
					ClutterStage* _tmp117_;
					ClutterActor* _tmp118_;
					GalaDragDropAction* _tmp119_;
					GalaDragDropAction* _tmp120_;
					_tmp113_ = actor;
					_tmp114_ = clutter_actor_get_parent (_tmp113_);
					_tmp115_ = _g_object_ref0 (_tmp114_);
					_g_object_unref0 (actor);
					actor = _tmp115_;
					_tmp116_ = actor;
					_tmp117_ = stage;
					if (!(_tmp116_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp117_, clutter_actor_get_type (), ClutterActor))) {
						break;
					}
					_tmp118_ = actor;
					_tmp119_ = gala_drag_drop_action_get_drag_drop_action (self, _tmp118_);
					_g_object_unref0 (action);
					action = _tmp119_;
					_tmp120_ = action;
					if (_tmp120_ != NULL) {
						break;
					}
				}
			}
			_tmp121_ = actor;
			_tmp122_ = self->priv->hovered;
			if (_tmp121_ == _tmp122_) {
				result = TRUE;
				_g_object_unref0 (action);
				_g_object_unref0 (actor);
				_g_object_unref0 (stage);
				return result;
			}
			_tmp123_ = action;
			if (_tmp123_ == NULL) {
				ClutterActor* _tmp124_;
				_tmp124_ = self->priv->hovered;
				if (_tmp124_ != NULL) {
					ClutterActor* _tmp125_;
					_tmp125_ = self->priv->hovered;
					gala_drag_drop_action_emit_crossed (self, _tmp125_, FALSE);
					_g_object_unref0 (self->priv->hovered);
					self->priv->hovered = NULL;
				}
				result = TRUE;
				_g_object_unref0 (action);
				_g_object_unref0 (actor);
				_g_object_unref0 (stage);
				return result;
			}
			_tmp126_ = self->priv->hovered;
			if (_tmp126_ != NULL) {
				ClutterActor* _tmp127_;
				_tmp127_ = self->priv->hovered;
				gala_drag_drop_action_emit_crossed (self, _tmp127_, FALSE);
			}
			_tmp128_ = actor;
			_tmp129_ = _g_object_ref0 (_tmp128_);
			_g_object_unref0 (self->priv->hovered);
			self->priv->hovered = _tmp129_;
			_tmp130_ = self->priv->hovered;
			gala_drag_drop_action_emit_crossed (self, _tmp130_, TRUE);
			result = TRUE;
			_g_object_unref0 (action);
			_g_object_unref0 (actor);
			_g_object_unref0 (stage);
			return result;
		}
		case CLUTTER_BUTTON_RELEASE:
		{
			ClutterActor* _tmp131_;
			_tmp131_ = self->priv->hovered;
			if (_tmp131_ != NULL) {
				gala_drag_drop_action_finish (self);
			} else {
				gala_drag_drop_action_cancel (self);
			}
			result = TRUE;
			return result;
		}
		case CLUTTER_ENTER:
		case CLUTTER_LEAVE:
		{
			result = TRUE;
			return result;
		}
		default:
		break;
	}
	result = FALSE;
	return result;
}


/**
 * Looks for a DragDropAction instance if this actor has one or NULL.
 * It also checks if it is a DESTINATION and if the id matches
 *
 * @return the DragDropAction instance on this actor or NULL
 */
static GalaDragDropAction* gala_drag_drop_action_get_drag_drop_action (GalaDragDropAction* self, ClutterActor* actor) {
	GalaDragDropAction* result = NULL;
	GalaDragDropAction* drop_action = NULL;
	ClutterActor* _tmp0_;
	GList* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (actor != NULL, NULL);
	drop_action = NULL;
	_tmp0_ = actor;
	_tmp1_ = clutter_actor_get_actions (_tmp0_);
	{
		GList* action_collection = NULL;
		GList* action_it = NULL;
		action_collection = _tmp1_;
		for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
			ClutterAction* action = NULL;
			action = (ClutterAction*) action_it->data;
			{
				ClutterAction* _tmp2_;
				GalaDragDropAction* _tmp3_;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				GalaDragDropAction* _tmp6_;
				_tmp2_ = action;
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GALA_TYPE_DRAG_DROP_ACTION) ? ((GalaDragDropAction*) _tmp2_) : NULL);
				_g_object_unref0 (drop_action);
				drop_action = _tmp3_;
				_tmp6_ = drop_action;
				if (_tmp6_ == NULL) {
					_tmp5_ = TRUE;
				} else {
					GalaDragDropAction* _tmp7_;
					GalaDragDropActionType _tmp8_;
					_tmp7_ = drop_action;
					_tmp8_ = _tmp7_->priv->_drag_type;
					_tmp5_ = _tmp8_ != GALA_DRAG_DROP_ACTION_TYPE_DESTINATION;
				}
				if (_tmp5_) {
					_tmp4_ = TRUE;
				} else {
					GalaDragDropAction* _tmp9_;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					_tmp9_ = drop_action;
					_tmp10_ = _tmp9_->priv->_drag_id;
					_tmp11_ = self->priv->_drag_id;
					_tmp4_ = g_strcmp0 (_tmp10_, _tmp11_) != 0;
				}
				if (_tmp4_) {
					continue;
				}
				result = drop_action;
				_g_list_free0 (action_collection);
				return result;
			}
		}
		_g_list_free0 (action_collection);
	}
	result = NULL;
	_g_object_unref0 (drop_action);
	return result;
}


/**
 * Abort the drag
 */
void gala_drag_drop_action_cancel (GalaDragDropAction* self) {
	g_return_if_fail (self != NULL);
	gala_drag_drop_action_cleanup (self);
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL], 0);
}


/**
 * Allows you to abort all drags currently running for a given drag-id
 */
void gala_drag_drop_action_cancel_all_by_id (const gchar* id) {
	GeeLinkedList* actors = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	GeeLinkedList* _tmp3_;
	g_return_if_fail (id != NULL);
	_tmp0_ = gala_drag_drop_action_sources;
	_tmp1_ = id;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
	actors = (GeeLinkedList*) _tmp2_;
	_tmp3_ = actors;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (actors);
		return;
	}
	{
		GeeLinkedList* _actor_list = NULL;
		GeeLinkedList* _tmp4_;
		GeeLinkedList* _tmp5_;
		gint _actor_size = 0;
		GeeLinkedList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _actor_index = 0;
		_tmp4_ = actors;
		_tmp5_ = _g_object_ref0 (_tmp4_);
		_actor_list = _tmp5_;
		_tmp6_ = _actor_list;
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
		_tmp8_ = _tmp7_;
		_actor_size = _tmp8_;
		_actor_index = -1;
		while (TRUE) {
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			ClutterActor* actor = NULL;
			GeeLinkedList* _tmp12_;
			gint _tmp13_;
			gpointer _tmp14_;
			ClutterActor* _tmp15_;
			GList* _tmp16_;
			_tmp9_ = _actor_index;
			_actor_index = _tmp9_ + 1;
			_tmp10_ = _actor_index;
			_tmp11_ = _actor_size;
			if (!(_tmp10_ < _tmp11_)) {
				break;
			}
			_tmp12_ = _actor_list;
			_tmp13_ = _actor_index;
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
			actor = (ClutterActor*) _tmp14_;
			_tmp15_ = actor;
			_tmp16_ = clutter_actor_get_actions (_tmp15_);
			{
				GList* action_collection = NULL;
				GList* action_it = NULL;
				action_collection = _tmp16_;
				for (action_it = action_collection; action_it != NULL; action_it = action_it->next) {
					ClutterAction* action = NULL;
					action = (ClutterAction*) action_it->data;
					{
						GalaDragDropAction* drag_action = NULL;
						ClutterAction* _tmp17_;
						GalaDragDropAction* _tmp18_;
						gboolean _tmp19_ = FALSE;
						GalaDragDropAction* _tmp20_;
						_tmp17_ = action;
						_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, GALA_TYPE_DRAG_DROP_ACTION) ? ((GalaDragDropAction*) _tmp17_) : NULL);
						drag_action = _tmp18_;
						_tmp20_ = drag_action;
						if (_tmp20_ != NULL) {
							GalaDragDropAction* _tmp21_;
							gboolean _tmp22_;
							_tmp21_ = drag_action;
							_tmp22_ = _tmp21_->priv->_dragging;
							_tmp19_ = _tmp22_;
						} else {
							_tmp19_ = FALSE;
						}
						if (_tmp19_) {
							GalaDragDropAction* _tmp23_;
							_tmp23_ = drag_action;
							gala_drag_drop_action_cancel (_tmp23_);
							_g_object_unref0 (drag_action);
							break;
						}
						_g_object_unref0 (drag_action);
					}
				}
				_g_list_free0 (action_collection);
			}
			_g_object_unref0 (actor);
		}
		_g_object_unref0 (_actor_list);
	}
	_g_object_unref0 (actors);
}


static void gala_drag_drop_action_finish (GalaDragDropAction* self) {
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->hovered;
	gala_drag_drop_action_emit_crossed (self, _tmp0_, FALSE);
	gala_drag_drop_action_cleanup (self);
	_tmp1_ = self->priv->hovered;
	g_signal_emit (self, gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL], 0, _tmp1_);
}


static void gala_drag_drop_action_cleanup (GalaDragDropAction* self) {
	GeeLinkedList* source_list = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	GeeLinkedList* _tmp3_;
	gboolean _tmp16_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gala_drag_drop_action_sources;
	_tmp1_ = self->priv->_drag_id;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
	source_list = (GeeLinkedList*) _tmp2_;
	_tmp3_ = source_list;
	if (_tmp3_ != NULL) {
		{
			GeeLinkedList* _actor_list = NULL;
			GeeLinkedList* _tmp4_;
			GeeLinkedList* _tmp5_;
			gint _actor_size = 0;
			GeeLinkedList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _actor_index = 0;
			_tmp4_ = source_list;
			_tmp5_ = _g_object_ref0 (_tmp4_);
			_actor_list = _tmp5_;
			_tmp6_ = _actor_list;
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
			_tmp8_ = _tmp7_;
			_actor_size = _tmp8_;
			_actor_index = -1;
			while (TRUE) {
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				ClutterActor* actor = NULL;
				GeeLinkedList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_;
				ClutterActor* _tmp15_;
				_tmp9_ = _actor_index;
				_actor_index = _tmp9_ + 1;
				_tmp10_ = _actor_index;
				_tmp11_ = _actor_size;
				if (!(_tmp10_ < _tmp11_)) {
					break;
				}
				_tmp12_ = _actor_list;
				_tmp13_ = _actor_index;
				_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
				actor = (ClutterActor*) _tmp14_;
				_tmp15_ = actor;
				clutter_actor_set_reactive (_tmp15_, TRUE);
				_g_object_unref0 (actor);
			}
			_g_object_unref0 (_actor_list);
		}
	}
	_tmp16_ = self->priv->_dragging;
	if (_tmp16_) {
		ClutterActor* _tmp17_;
		ClutterActor* _tmp18_;
		ClutterStage* _tmp19_;
		guint _tmp20_;
		_tmp17_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
		_tmp18_ = _tmp17_;
		_tmp19_ = clutter_actor_get_stage (_tmp18_);
		g_signal_parse_name ("captured-event", clutter_actor_get_type (), &_tmp20_, NULL, FALSE);
		g_signal_handlers_disconnect_matched ((ClutterActor*) _tmp19_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _gala_drag_drop_action_follow_move_clutter_actor_captured_event, self);
	}
	gala_drag_drop_action_set_dragging (self, FALSE);
	_g_object_unref0 (source_list);
}


GalaDragDropActionType gala_drag_drop_action_get_drag_type (GalaDragDropAction* self) {
	GalaDragDropActionType result;
	GalaDragDropActionType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_drag_type;
	result = _tmp0_;
	return result;
}


static void gala_drag_drop_action_set_drag_type (GalaDragDropAction* self, GalaDragDropActionType value) {
	g_return_if_fail (self != NULL);
	if (gala_drag_drop_action_get_drag_type (self) != value) {
		GalaDragDropActionType _tmp0_;
		_tmp0_ = value;
		self->priv->_drag_type = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY]);
	}
}


const gchar* gala_drag_drop_action_get_drag_id (GalaDragDropAction* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_drag_id;
	result = _tmp0_;
	return result;
}


static void gala_drag_drop_action_set_drag_id (GalaDragDropAction* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, gala_drag_drop_action_get_drag_id (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_drag_id);
		self->priv->_drag_id = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY]);
	}
}


ClutterActor* gala_drag_drop_action_get_handle (GalaDragDropAction* self) {
	ClutterActor* result;
	ClutterActor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_handle;
	result = _tmp0_;
	return result;
}


static void gala_drag_drop_action_set_handle (GalaDragDropAction* self, ClutterActor* value) {
	g_return_if_fail (self != NULL);
	if (gala_drag_drop_action_get_handle (self) != value) {
		ClutterActor* _tmp0_;
		ClutterActor* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_handle);
		self->priv->_handle = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY]);
	}
}


gboolean gala_drag_drop_action_get_dragging (GalaDragDropAction* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_dragging;
	result = _tmp0_;
	return result;
}


static void gala_drag_drop_action_set_dragging (GalaDragDropAction* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (gala_drag_drop_action_get_dragging (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_dragging = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY]);
	}
}


gboolean gala_drag_drop_action_get_allow_bubbling (GalaDragDropAction* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_allow_bubbling;
	result = _tmp0_;
	return result;
}


void gala_drag_drop_action_set_allow_bubbling (GalaDragDropAction* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (gala_drag_drop_action_get_allow_bubbling (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_allow_bubbling = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY]);
	}
}


static void g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef gpointer (*GMarshalFunc_OBJECT__FLOAT_FLOAT) (gpointer data1, gfloat arg_1, gfloat arg_2, gpointer data2);
	register GMarshalFunc_OBJECT__FLOAT_FLOAT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gpointer v_return;
	cc = (GCClosure *) closure;
	g_return_if_fail (return_value != NULL);
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_OBJECT__FLOAT_FLOAT) (marshal_data ? marshal_data : cc->callback);
	v_return = callback (data1, g_value_get_float (param_values + 1), g_value_get_float (param_values + 2), data2);
	g_value_take_object (return_value, v_return);
}


static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}


static void gala_drag_drop_action_class_init (GalaDragDropActionClass * klass) {
	gala_drag_drop_action_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GalaDragDropActionPrivate));
	((ClutterActorMetaClass *) klass)->set_actor = (void (*) (ClutterActorMeta *, ClutterActor*)) gala_drag_drop_action_real_set_actor;
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_drag_drop_action_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_drag_drop_action_set_property;
	G_OBJECT_CLASS (klass)->finalize = gala_drag_drop_action_finalize;
	/**
	 * The type of the action
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY] = g_param_spec_enum ("drag-type", "drag-type", "drag-type", GALA_TYPE_DRAG_DROP_ACTION_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	 * The unique id given to this drag-drop-group
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY] = g_param_spec_string ("drag-id", "drag-id", "drag-id", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY] = g_param_spec_object ("handle", "handle", "handle", clutter_actor_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	 * Indicates whether a drag action is currently active
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY] = g_param_spec_boolean ("dragging", "dragging", "dragging", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	 * Allow checking the parents of reactive children if they are valid destinations
	 * if the child is none
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY, gala_drag_drop_action_properties[GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY] = g_param_spec_boolean ("allow-bubbling", "allow-bubbling", "allow-bubbling", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * A drag has been started. You have to connect to this signal and
	 * return an actor that is transformed during the drag operation.
	 *
	 * @param x The global x coordinate where the action was activated
	 * @param y The global y coordinate where the action was activated
	 * @return  A ClutterActor that serves as handle
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_BEGIN_SIGNAL] = g_signal_new ("drag-begin", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_OBJECT__FLOAT_FLOAT, clutter_actor_get_type (), 2, G_TYPE_FLOAT, G_TYPE_FLOAT);
	/**
	 * A drag has been canceled. You may want to consider cleaning up
	 * your handle.
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_CANCELED_SIGNAL] = g_signal_new ("drag-canceled", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	 * A drag action has successfully been finished.
	 *
	 * @param actor The actor on which the drag finished
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DRAG_END_SIGNAL] = g_signal_new ("drag-end", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, clutter_actor_get_type ());
	/**
	 * The destination has been crossed
	 *
	 * @param hovered indicates whether the actor is now hovered or not
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_CROSSED_SIGNAL] = g_signal_new ("crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	/**
	 * Emitted on the source when a destination is crossed.
	 *
	 * @param destination The destination actor that has been crossed
	 * @param hovered     Whether the actor is now hovered or has just been left
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_DESTINATION_CROSSED_SIGNAL] = g_signal_new ("destination-crossed", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, clutter_actor_get_type (), G_TYPE_BOOLEAN);
	/**
	 * The source has been clicked, but the movement was not larger than
	 * the drag threshold. Useful if the source is also activable.
	 *
	 * @param button The button which was pressed
	 */
	gala_drag_drop_action_signals[GALA_DRAG_DROP_ACTION_ACTOR_CLICKED_SIGNAL] = g_signal_new ("actor-clicked", GALA_TYPE_DRAG_DROP_ACTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
}


static void gala_drag_drop_action_instance_init (GalaDragDropAction * self) {
	self->priv = GALA_DRAG_DROP_ACTION_GET_PRIVATE (self);
	self->priv->_dragging = FALSE;
	self->priv->_allow_bubbling = TRUE;
	self->priv->hovered = NULL;
	self->priv->clicked = FALSE;
}


static void gala_drag_drop_action_finalize (GObject * obj) {
	GalaDragDropAction * self;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
	_tmp0_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != NULL) {
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
		_tmp2_ = clutter_actor_meta_get_actor ((ClutterActorMeta*) self);
		_tmp3_ = _tmp2_;
		gala_drag_drop_action_release_actor (self, _tmp3_);
	}
	_g_free0 (self->priv->_drag_id);
	_g_object_unref0 (self->priv->_handle);
	_g_object_unref0 (self->priv->hovered);
	G_OBJECT_CLASS (gala_drag_drop_action_parent_class)->finalize (obj);
}


GType gala_drag_drop_action_get_type (void) {
	static volatile gsize gala_drag_drop_action_type_id__volatile = 0;
	if (g_once_init_enter (&gala_drag_drop_action_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaDragDropActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_drag_drop_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaDragDropAction), 0, (GInstanceInitFunc) gala_drag_drop_action_instance_init, NULL };
		GType gala_drag_drop_action_type_id;
		gala_drag_drop_action_type_id = g_type_register_static (clutter_action_get_type (), "GalaDragDropAction", &g_define_type_info, 0);
		g_once_init_leave (&gala_drag_drop_action_type_id__volatile, gala_drag_drop_action_type_id);
	}
	return gala_drag_drop_action_type_id__volatile;
}


static void _vala_gala_drag_drop_action_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
	switch (property_id) {
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY:
		g_value_set_enum (value, gala_drag_drop_action_get_drag_type (self));
		break;
		case GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY:
		g_value_set_string (value, gala_drag_drop_action_get_drag_id (self));
		break;
		case GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY:
		g_value_set_object (value, gala_drag_drop_action_get_handle (self));
		break;
		case GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY:
		g_value_set_boolean (value, gala_drag_drop_action_get_dragging (self));
		break;
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY:
		g_value_set_boolean (value, gala_drag_drop_action_get_allow_bubbling (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gala_drag_drop_action_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaDragDropAction * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_DRAG_DROP_ACTION, GalaDragDropAction);
	switch (property_id) {
		case GALA_DRAG_DROP_ACTION_DRAG_TYPE_PROPERTY:
		gala_drag_drop_action_set_drag_type (self, g_value_get_enum (value));
		break;
		case GALA_DRAG_DROP_ACTION_DRAG_ID_PROPERTY:
		gala_drag_drop_action_set_drag_id (self, g_value_get_string (value));
		break;
		case GALA_DRAG_DROP_ACTION_HANDLE_PROPERTY:
		gala_drag_drop_action_set_handle (self, g_value_get_object (value));
		break;
		case GALA_DRAG_DROP_ACTION_DRAGGING_PROPERTY:
		gala_drag_drop_action_set_dragging (self, g_value_get_boolean (value));
		break;
		case GALA_DRAG_DROP_ACTION_ALLOW_BUBBLING_PROPERTY:
		gala_drag_drop_action_set_allow_bubbling (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



