/* SelectionArea.c generated by valac 0.38.10, the Vala compiler
 * generated from SelectionArea.vala, do not modify */

/**/
/*  Copyright (C) 2017 Santiago León O., Adam Bieńkowski*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include "gala.h"
#include <gdk/gdk.h>
#include <meta/meta-plugin.h>
#include <meta/screen.h>
#include <meta/common.h>
#include <stdlib.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define GALA_TYPE_SELECTION_AREA (gala_selection_area_get_type ())
#define GALA_SELECTION_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SELECTION_AREA, GalaSelectionArea))
#define GALA_SELECTION_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SELECTION_AREA, GalaSelectionAreaClass))
#define GALA_IS_SELECTION_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SELECTION_AREA))
#define GALA_IS_SELECTION_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SELECTION_AREA))
#define GALA_SELECTION_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SELECTION_AREA, GalaSelectionAreaClass))

typedef struct _GalaSelectionArea GalaSelectionArea;
typedef struct _GalaSelectionAreaClass GalaSelectionAreaClass;
typedef struct _GalaSelectionAreaPrivate GalaSelectionAreaPrivate;
enum  {
	GALA_SELECTION_AREA_0_PROPERTY,
	GALA_SELECTION_AREA_WM_PROPERTY,
	GALA_SELECTION_AREA_NUM_PROPERTIES
};
static GParamSpec* gala_selection_area_properties[GALA_SELECTION_AREA_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GALA_SELECTION_AREA_CLOSED_SIGNAL,
	GALA_SELECTION_AREA_NUM_SIGNALS
};
static guint gala_selection_area_signals[GALA_SELECTION_AREA_NUM_SIGNALS] = {0};

struct _GalaSelectionArea {
	ClutterActor parent_instance;
	GalaSelectionAreaPrivate * priv;
};

struct _GalaSelectionAreaClass {
	ClutterActorClass parent_class;
};

struct _GalaSelectionAreaPrivate {
	GalaWindowManager* _wm;
	GalaModalProxy* modal_proxy;
	GdkPoint start_point;
	GdkPoint end_point;
	gboolean dragging;
	gboolean clicked;
};


static gpointer gala_selection_area_parent_class = NULL;

GType gala_selection_area_get_type (void) G_GNUC_CONST;
#define GALA_SELECTION_AREA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_SELECTION_AREA, GalaSelectionAreaPrivate))
GalaSelectionArea* gala_selection_area_new (GalaWindowManager* wm);
GalaSelectionArea* gala_selection_area_construct (GType object_type, GalaWindowManager* wm);
static gboolean gala_selection_area_real_key_press_event (ClutterActor* base, ClutterKeyEvent* e);
void gala_selection_area_close (GalaSelectionArea* self);
static gboolean gala_selection_area_real_button_press_event (ClutterActor* base, ClutterButtonEvent* e);
static gboolean gala_selection_area_real_button_release_event (ClutterActor* base, ClutterButtonEvent* e);
static gboolean gala_selection_area_real_motion_event (ClutterActor* base, ClutterMotionEvent* e);
GalaWindowManager* gala_selection_area_get_wm (GalaSelectionArea* self);
void gala_selection_area_start_selection (GalaSelectionArea* self);
void gala_selection_area_get_selection_rectangle (GalaSelectionArea* self, gint* x, gint* y, gint* width, gint* height);
static gboolean gala_selection_area_draw_area (GalaSelectionArea* self, cairo_t* ctx);
static void gala_selection_area_set_wm (GalaSelectionArea* self, GalaWindowManager* value);
static GObject * gala_selection_area_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gboolean _gala_selection_area_draw_area_clutter_canvas_draw (ClutterCanvas* _sender, cairo_t* cr, gint width, gint height, gpointer self);
static void gala_selection_area_finalize (GObject * obj);
static void _vala_gala_selection_area_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_selection_area_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GalaSelectionArea* gala_selection_area_construct (GType object_type, GalaWindowManager* wm) {
	GalaSelectionArea * self = NULL;
	GalaWindowManager* _tmp0_;
	g_return_val_if_fail (wm != NULL, NULL);
	_tmp0_ = wm;
	self = (GalaSelectionArea*) g_object_new (object_type, "wm", _tmp0_, NULL);
	return self;
}


GalaSelectionArea* gala_selection_area_new (GalaWindowManager* wm) {
	return gala_selection_area_construct (GALA_TYPE_SELECTION_AREA, wm);
}


static gboolean gala_selection_area_real_key_press_event (ClutterActor* base, ClutterKeyEvent* e) {
	GalaSelectionArea * self;
	gboolean result = FALSE;
	ClutterKeyEvent* _tmp0_;
	guint _tmp1_;
	self = (GalaSelectionArea*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = e;
	_tmp1_ = _tmp0_->keyval;
	if (_tmp1_ == ((guint) CLUTTER_KEY_Escape)) {
		gala_selection_area_close (self);
		g_signal_emit (self, gala_selection_area_signals[GALA_SELECTION_AREA_CLOSED_SIGNAL], 0);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean gala_selection_area_real_button_press_event (ClutterActor* base, ClutterButtonEvent* e) {
	GalaSelectionArea * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	ClutterButtonEvent* _tmp4_;
	gfloat _tmp5_;
	ClutterButtonEvent* _tmp6_;
	gfloat _tmp7_;
	self = (GalaSelectionArea*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp1_ = self->priv->dragging;
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		ClutterButtonEvent* _tmp2_;
		guint32 _tmp3_;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->button;
		_tmp0_ = _tmp3_ != ((guint32) 1);
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	self->priv->clicked = TRUE;
	_tmp4_ = e;
	_tmp5_ = _tmp4_->x;
	self->priv->start_point.x = (gint) _tmp5_;
	_tmp6_ = e;
	_tmp7_ = _tmp6_->y;
	self->priv->start_point.y = (gint) _tmp7_;
	result = TRUE;
	return result;
}


static gboolean gala_selection_area_real_button_release_event (ClutterActor* base, ClutterButtonEvent* e) {
	GalaSelectionArea * self;
	gboolean result = FALSE;
	ClutterButtonEvent* _tmp0_;
	guint32 _tmp1_;
	gboolean _tmp2_;
	ClutterContent* _tmp3_;
	ClutterContent* _tmp4_;
	self = (GalaSelectionArea*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = e;
	_tmp1_ = _tmp0_->button;
	if (_tmp1_ != ((guint32) 1)) {
		result = TRUE;
		return result;
	}
	_tmp2_ = self->priv->dragging;
	if (!_tmp2_) {
		gala_selection_area_close (self);
		g_signal_emit (self, gala_selection_area_signals[GALA_SELECTION_AREA_CLOSED_SIGNAL], 0);
		result = TRUE;
		return result;
	}
	self->priv->dragging = FALSE;
	self->priv->clicked = FALSE;
	gala_selection_area_close (self);
	clutter_actor_hide ((ClutterActor*) self);
	_tmp3_ = clutter_actor_get_content ((ClutterActor*) self);
	_tmp4_ = _tmp3_;
	clutter_content_invalidate (_tmp4_);
	g_signal_emit (self, gala_selection_area_signals[GALA_SELECTION_AREA_CLOSED_SIGNAL], 0);
	result = TRUE;
	return result;
}


static gboolean gala_selection_area_real_motion_event (ClutterActor* base, ClutterMotionEvent* e) {
	GalaSelectionArea * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	ClutterMotionEvent* _tmp1_;
	gfloat _tmp2_;
	ClutterMotionEvent* _tmp3_;
	gfloat _tmp4_;
	ClutterContent* _tmp5_;
	ClutterContent* _tmp6_;
	gboolean _tmp7_;
	self = (GalaSelectionArea*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = self->priv->clicked;
	if (!_tmp0_) {
		result = TRUE;
		return result;
	}
	_tmp1_ = e;
	_tmp2_ = _tmp1_->x;
	self->priv->end_point.x = (gint) _tmp2_;
	_tmp3_ = e;
	_tmp4_ = _tmp3_->y;
	self->priv->end_point.y = (gint) _tmp4_;
	_tmp5_ = clutter_actor_get_content ((ClutterActor*) self);
	_tmp6_ = _tmp5_;
	clutter_content_invalidate (_tmp6_);
	_tmp7_ = self->priv->dragging;
	if (!_tmp7_) {
		self->priv->dragging = TRUE;
	}
	result = TRUE;
	return result;
}


void gala_selection_area_close (GalaSelectionArea* self) {
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	GalaModalProxy* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	meta_screen_set_cursor (_tmp1_, META_CURSOR_DEFAULT);
	_tmp2_ = self->priv->modal_proxy;
	if (_tmp2_ != NULL) {
		GalaWindowManager* _tmp3_;
		GalaModalProxy* _tmp4_;
		_tmp3_ = self->priv->_wm;
		_tmp4_ = self->priv->modal_proxy;
		gala_window_manager_pop_modal (_tmp3_, _tmp4_);
	}
}


void gala_selection_area_start_selection (GalaSelectionArea* self) {
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	GalaWindowManager* _tmp2_;
	GalaModalProxy* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	meta_screen_set_cursor (_tmp1_, META_CURSOR_CROSSHAIR);
	clutter_actor_grab_key_focus ((ClutterActor*) self);
	_tmp2_ = self->priv->_wm;
	_tmp3_ = gala_window_manager_push_modal (_tmp2_);
	_g_object_unref0 (self->priv->modal_proxy);
	self->priv->modal_proxy = _tmp3_;
}


void gala_selection_area_get_selection_rectangle (GalaSelectionArea* self, gint* x, gint* y, gint* width, gint* height) {
	gint _vala_x = 0;
	gint _vala_y = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GdkPoint _tmp5_;
	gint _tmp6_;
	GdkPoint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkPoint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GdkPoint _tmp15_;
	gint _tmp16_;
	GdkPoint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->start_point;
	_tmp1_ = _tmp0_.x;
	_tmp2_ = self->priv->end_point;
	_tmp3_ = _tmp2_.x;
	_tmp4_ = MIN (_tmp1_, _tmp3_);
	_vala_x = _tmp4_;
	_tmp5_ = self->priv->start_point;
	_tmp6_ = _tmp5_.y;
	_tmp7_ = self->priv->end_point;
	_tmp8_ = _tmp7_.y;
	_tmp9_ = MIN (_tmp6_, _tmp8_);
	_vala_y = _tmp9_;
	_tmp10_ = self->priv->start_point;
	_tmp11_ = _tmp10_.x;
	_tmp12_ = self->priv->end_point;
	_tmp13_ = _tmp12_.x;
	_tmp14_ = abs (_tmp11_ - _tmp13_);
	_vala_width = _tmp14_;
	_tmp15_ = self->priv->start_point;
	_tmp16_ = _tmp15_.y;
	_tmp17_ = self->priv->end_point;
	_tmp18_ = _tmp17_.y;
	_tmp19_ = abs (_tmp16_ - _tmp18_);
	_vala_height = _tmp19_;
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
}


static gboolean gala_selection_area_draw_area (GalaSelectionArea* self, cairo_t* ctx) {
	gboolean result = FALSE;
	cairo_t* _tmp0_;
	gboolean _tmp1_;
	gint x = 0;
	gint y = 0;
	gint w = 0;
	gint h = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	cairo_t* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	cairo_t* _tmp18_;
	cairo_t* _tmp19_;
	cairo_t* _tmp20_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp0_ = ctx;
	clutter_cairo_clear (_tmp0_);
	_tmp1_ = self->priv->dragging;
	if (!_tmp1_) {
		result = TRUE;
		return result;
	}
	gala_selection_area_get_selection_rectangle (self, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	x = _tmp2_;
	y = _tmp3_;
	w = _tmp4_;
	h = _tmp5_;
	_tmp6_ = ctx;
	_tmp7_ = x;
	_tmp8_ = y;
	_tmp9_ = w;
	_tmp10_ = h;
	cairo_rectangle (_tmp6_, (gdouble) _tmp7_, (gdouble) _tmp8_, (gdouble) _tmp9_, (gdouble) _tmp10_);
	_tmp11_ = ctx;
	cairo_set_source_rgba (_tmp11_, 0.1, 0.1, 0.1, 0.2);
	_tmp12_ = ctx;
	cairo_fill (_tmp12_);
	_tmp13_ = ctx;
	_tmp14_ = x;
	_tmp15_ = y;
	_tmp16_ = w;
	_tmp17_ = h;
	cairo_rectangle (_tmp13_, (gdouble) _tmp14_, (gdouble) _tmp15_, (gdouble) _tmp16_, (gdouble) _tmp17_);
	_tmp18_ = ctx;
	cairo_set_source_rgb (_tmp18_, 0.7, 0.7, 0.7);
	_tmp19_ = ctx;
	cairo_set_line_width (_tmp19_, 1.0);
	_tmp20_ = ctx;
	cairo_stroke (_tmp20_);
	result = TRUE;
	return result;
}


GalaWindowManager* gala_selection_area_get_wm (GalaSelectionArea* self) {
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_wm;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void gala_selection_area_set_wm (GalaSelectionArea* self, GalaWindowManager* value) {
	g_return_if_fail (self != NULL);
	if (gala_selection_area_get_wm (self) != value) {
		GalaWindowManager* _tmp0_;
		GalaWindowManager* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_wm);
		self->priv->_wm = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, gala_selection_area_properties[GALA_SELECTION_AREA_WM_PROPERTY]);
	}
}


static gboolean _gala_selection_area_draw_area_clutter_canvas_draw (ClutterCanvas* _sender, cairo_t* cr, gint width, gint height, gpointer self) {
	gboolean result;
	result = gala_selection_area_draw_area ((GalaSelectionArea*) self, cr);
	return result;
}


static GObject * gala_selection_area_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GalaSelectionArea * self;
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	gint screen_width = 0;
	gint screen_height = 0;
	GalaWindowManager* _tmp2_;
	MetaScreen* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_;
	gint _tmp7_;
	ClutterCanvas* canvas = NULL;
	ClutterCanvas* _tmp8_;
	ClutterCanvas* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	ClutterCanvas* _tmp12_;
	ClutterCanvas* _tmp13_;
	ClutterCanvas* _tmp14_;
	parent_class = G_OBJECT_CLASS (gala_selection_area_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_SELECTION_AREA, GalaSelectionArea);
	_tmp0_.x = 0;
	_tmp0_.y = 0;
	self->priv->start_point = _tmp0_;
	_tmp1_.x = 0;
	_tmp1_.y = 0;
	self->priv->end_point = _tmp1_;
	g_object_set ((ClutterActor*) self, "visible", TRUE, NULL);
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
	_tmp2_ = self->priv->_wm;
	_tmp3_ = meta_plugin_get_screen ((MetaPlugin*) _tmp2_);
	meta_screen_get_size (_tmp3_, &_tmp4_, &_tmp5_);
	screen_width = _tmp4_;
	screen_height = _tmp5_;
	_tmp6_ = screen_width;
	clutter_actor_set_width ((ClutterActor*) self, (gfloat) _tmp6_);
	_tmp7_ = screen_height;
	clutter_actor_set_height ((ClutterActor*) self, (gfloat) _tmp7_);
	_tmp8_ = (ClutterCanvas*) clutter_canvas_new ();
	canvas = _tmp8_;
	_tmp9_ = canvas;
	_tmp10_ = screen_width;
	_tmp11_ = screen_height;
	clutter_canvas_set_size (_tmp9_, _tmp10_, _tmp11_);
	_tmp12_ = canvas;
	g_signal_connect_object (_tmp12_, "draw", (GCallback) _gala_selection_area_draw_area_clutter_canvas_draw, self, 0);
	_tmp13_ = canvas;
	clutter_actor_set_content ((ClutterActor*) self, (ClutterContent*) _tmp13_);
	_tmp14_ = canvas;
	clutter_content_invalidate ((ClutterContent*) _tmp14_);
	_g_object_unref0 (canvas);
	return obj;
}


static void gala_selection_area_class_init (GalaSelectionAreaClass * klass) {
	gala_selection_area_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GalaSelectionAreaPrivate));
	((ClutterActorClass *) klass)->key_press_event = (gboolean (*) (ClutterActor *, ClutterKeyEvent*)) gala_selection_area_real_key_press_event;
	((ClutterActorClass *) klass)->button_press_event = (gboolean (*) (ClutterActor *, ClutterButtonEvent*)) gala_selection_area_real_button_press_event;
	((ClutterActorClass *) klass)->button_release_event = (gboolean (*) (ClutterActor *, ClutterButtonEvent*)) gala_selection_area_real_button_release_event;
	((ClutterActorClass *) klass)->motion_event = (gboolean (*) (ClutterActor *, ClutterMotionEvent*)) gala_selection_area_real_motion_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_selection_area_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_selection_area_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_selection_area_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_selection_area_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_SELECTION_AREA_WM_PROPERTY, gala_selection_area_properties[GALA_SELECTION_AREA_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	gala_selection_area_signals[GALA_SELECTION_AREA_CLOSED_SIGNAL] = g_signal_new ("closed", GALA_TYPE_SELECTION_AREA, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void gala_selection_area_instance_init (GalaSelectionArea * self) {
	self->priv = GALA_SELECTION_AREA_GET_PRIVATE (self);
	self->priv->dragging = FALSE;
	self->priv->clicked = FALSE;
}


static void gala_selection_area_finalize (GObject * obj) {
	GalaSelectionArea * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_SELECTION_AREA, GalaSelectionArea);
	_g_object_unref0 (self->priv->_wm);
	_g_object_unref0 (self->priv->modal_proxy);
	G_OBJECT_CLASS (gala_selection_area_parent_class)->finalize (obj);
}


GType gala_selection_area_get_type (void) {
	static volatile gsize gala_selection_area_type_id__volatile = 0;
	if (g_once_init_enter (&gala_selection_area_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaSelectionAreaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_selection_area_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaSelectionArea), 0, (GInstanceInitFunc) gala_selection_area_instance_init, NULL };
		GType gala_selection_area_type_id;
		gala_selection_area_type_id = g_type_register_static (clutter_actor_get_type (), "GalaSelectionArea", &g_define_type_info, 0);
		g_once_init_leave (&gala_selection_area_type_id__volatile, gala_selection_area_type_id);
	}
	return gala_selection_area_type_id__volatile;
}


static void _vala_gala_selection_area_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaSelectionArea * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_SELECTION_AREA, GalaSelectionArea);
	switch (property_id) {
		case GALA_SELECTION_AREA_WM_PROPERTY:
		g_value_set_object (value, gala_selection_area_get_wm (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gala_selection_area_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaSelectionArea * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_SELECTION_AREA, GalaSelectionArea);
	switch (property_id) {
		case GALA_SELECTION_AREA_WM_PROPERTY:
		gala_selection_area_set_wm (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



