/* WindowListener.c generated by valac 0.38.10, the Vala compiler
 * generated from WindowListener.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <meta/boxes.h>
#include <string.h>
#include <gee.h>
#include <meta/window.h>
#include <meta/screen.h>
#include <meta/compositor-mutter.h>
#include <meta/meta-window-actor.h>
#include <meta/display.h>


#define GALA_TYPE_WINDOW_GEOMETRY (gala_window_geometry_get_type ())
typedef struct _GalaWindowGeometry GalaWindowGeometry;

#define GALA_TYPE_WINDOW_LISTENER (gala_window_listener_get_type ())
#define GALA_WINDOW_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_LISTENER, GalaWindowListener))
#define GALA_WINDOW_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_LISTENER, GalaWindowListenerClass))
#define GALA_IS_WINDOW_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_LISTENER))
#define GALA_IS_WINDOW_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_LISTENER))
#define GALA_WINDOW_LISTENER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_LISTENER, GalaWindowListenerClass))

typedef struct _GalaWindowListener GalaWindowListener;
typedef struct _GalaWindowListenerClass GalaWindowListenerClass;
typedef struct _GalaWindowListenerPrivate GalaWindowListenerPrivate;
enum  {
	GALA_WINDOW_LISTENER_0_PROPERTY,
	GALA_WINDOW_LISTENER_NUM_PROPERTIES
};
static GParamSpec* gala_window_listener_properties[GALA_WINDOW_LISTENER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GALA_WINDOW_LISTENER_WINDOW_NO_LONGER_ON_ALL_WORKSPACES_SIGNAL,
	GALA_WINDOW_LISTENER_NUM_SIGNALS
};
static guint gala_window_listener_signals[GALA_WINDOW_LISTENER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaWindowGeometry {
	MetaRectangle inner;
	MetaRectangle outer;
};

struct _GalaWindowListener {
	GObject parent_instance;
	GalaWindowListenerPrivate * priv;
};

struct _GalaWindowListenerClass {
	GObjectClass parent_class;
};

struct _GalaWindowListenerPrivate {
	GeeHashMap* unmaximized_state_geometry;
};


static gpointer gala_window_listener_parent_class = NULL;
static GalaWindowListener* gala_window_listener_instance;
static GalaWindowListener* gala_window_listener_instance = NULL;

GType gala_window_geometry_get_type (void) G_GNUC_CONST;
GalaWindowGeometry* gala_window_geometry_dup (const GalaWindowGeometry* self);
void gala_window_geometry_free (GalaWindowGeometry* self);
GType gala_window_listener_get_type (void) G_GNUC_CONST;
#define GALA_WINDOW_LISTENER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_WINDOW_LISTENER, GalaWindowListenerPrivate))
void gala_window_listener_init (MetaScreen* screen);
static GalaWindowListener* gala_window_listener_new (void);
static GalaWindowListener* gala_window_listener_construct (GType object_type);
static void gala_window_listener_monitor_window (GalaWindowListener* self, MetaWindow* window);
static void __lambda55_ (MetaWindow* window);
static void ___lambda55__meta_display_window_created (MetaDisplay* _sender, MetaWindow* object, gpointer self);
GalaWindowListener* gala_window_listener_get_default (void);
static void gala_window_listener_window_notify (GalaWindowListener* self, GObject* object, GParamSpec* pspec);
static void _gala_window_listener_window_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void gala_window_listener_window_removed (GalaWindowListener* self, MetaWindow* window);
static void _gala_window_listener_window_removed_meta_window_unmanaged (MetaWindow* _sender, gpointer self);
static void gala_window_listener_window_maximized_changed (GalaWindowListener* self, MetaWindow* window);
static void gala_window_listener_window_on_all_workspaces_changed (GalaWindowListener* self, MetaWindow* window);
GalaWindowGeometry* gala_window_listener_get_unmaximized_state_geometry (GalaWindowListener* self, MetaWindow* window);
static void gala_window_listener_finalize (GObject * obj);


GalaWindowGeometry* gala_window_geometry_dup (const GalaWindowGeometry* self) {
	GalaWindowGeometry* dup;
	dup = g_new0 (GalaWindowGeometry, 1);
	memcpy (dup, self, sizeof (GalaWindowGeometry));
	return dup;
}


void gala_window_geometry_free (GalaWindowGeometry* self) {
	g_free (self);
}


GType gala_window_geometry_get_type (void) {
	static volatile gsize gala_window_geometry_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_geometry_type_id__volatile)) {
		GType gala_window_geometry_type_id;
		gala_window_geometry_type_id = g_boxed_type_register_static ("GalaWindowGeometry", (GBoxedCopyFunc) gala_window_geometry_dup, (GBoxedFreeFunc) gala_window_geometry_free);
		g_once_init_leave (&gala_window_geometry_type_id__volatile, gala_window_geometry_type_id);
	}
	return gala_window_geometry_type_id__volatile;
}


static void __lambda55_ (MetaWindow* window) {
	MetaWindow* _tmp0_;
	MetaWindowType _tmp1_;
	MetaWindowType _tmp2_;
	g_return_if_fail (window != NULL);
	_tmp0_ = window;
	_tmp1_ = meta_window_get_window_type (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == META_WINDOW_NORMAL) {
		GalaWindowListener* _tmp3_;
		MetaWindow* _tmp4_;
		_tmp3_ = gala_window_listener_instance;
		_tmp4_ = window;
		gala_window_listener_monitor_window (_tmp3_, _tmp4_);
	}
}


static void ___lambda55__meta_display_window_created (MetaDisplay* _sender, MetaWindow* object, gpointer self) {
	__lambda55_ (object);
}


void gala_window_listener_init (MetaScreen* screen) {
	GalaWindowListener* _tmp0_;
	GalaWindowListener* _tmp1_;
	MetaScreen* _tmp2_;
	GList* _tmp3_;
	MetaScreen* _tmp13_;
	MetaDisplay* _tmp14_;
	g_return_if_fail (screen != NULL);
	_tmp0_ = gala_window_listener_instance;
	if (_tmp0_ != NULL) {
		return;
	}
	_tmp1_ = gala_window_listener_new ();
	_g_object_unref0 (gala_window_listener_instance);
	gala_window_listener_instance = _tmp1_;
	_tmp2_ = screen;
	_tmp3_ = meta_get_window_actors (_tmp2_);
	{
		GList* actor_collection = NULL;
		GList* actor_it = NULL;
		actor_collection = _tmp3_;
		for (actor_it = actor_collection; actor_it != NULL; actor_it = actor_it->next) {
			MetaWindowActor* actor = NULL;
			actor = (MetaWindowActor*) actor_it->data;
			{
				MetaWindowActor* _tmp4_;
				gboolean _tmp5_;
				MetaWindow* window = NULL;
				MetaWindowActor* _tmp6_;
				MetaWindow* _tmp7_;
				MetaWindow* _tmp8_;
				MetaWindowType _tmp9_;
				MetaWindowType _tmp10_;
				_tmp4_ = actor;
				_tmp5_ = meta_window_actor_is_destroyed (_tmp4_);
				if (_tmp5_) {
					continue;
				}
				_tmp6_ = actor;
				_tmp7_ = meta_window_actor_get_meta_window (_tmp6_);
				window = _tmp7_;
				_tmp8_ = window;
				_tmp9_ = meta_window_get_window_type (_tmp8_);
				_tmp10_ = _tmp9_;
				if (_tmp10_ == META_WINDOW_NORMAL) {
					GalaWindowListener* _tmp11_;
					MetaWindow* _tmp12_;
					_tmp11_ = gala_window_listener_instance;
					_tmp12_ = window;
					gala_window_listener_monitor_window (_tmp11_, _tmp12_);
				}
			}
		}
	}
	_tmp13_ = screen;
	_tmp14_ = meta_screen_get_display (_tmp13_);
	g_signal_connect (_tmp14_, "window-created", (GCallback) ___lambda55__meta_display_window_created, NULL);
}


GalaWindowListener* gala_window_listener_get_default (void) {
	GalaWindowListener* result = NULL;
	GalaWindowListener* _tmp0_;
	GalaWindowListener* _tmp1_;
	_tmp0_ = gala_window_listener_instance;
	_vala_return_val_if_fail (_tmp0_ != NULL, "instance != null", NULL);
	_tmp1_ = gala_window_listener_instance;
	result = _tmp1_;
	return result;
}


static GalaWindowListener* gala_window_listener_construct (GType object_type) {
	GalaWindowListener * self = NULL;
	GeeHashMap* _tmp0_;
	self = (GalaWindowListener*) g_object_new (object_type, NULL);
	_tmp0_ = gee_hash_map_new (meta_window_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GALA_TYPE_WINDOW_GEOMETRY, (GBoxedCopyFunc) gala_window_geometry_dup, (GDestroyNotify) gala_window_geometry_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->unmaximized_state_geometry);
	self->priv->unmaximized_state_geometry = _tmp0_;
	return self;
}


static GalaWindowListener* gala_window_listener_new (void) {
	return gala_window_listener_construct (GALA_TYPE_WINDOW_LISTENER);
}


static void _gala_window_listener_window_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	gala_window_listener_window_notify ((GalaWindowListener*) self, _sender, pspec);
}


static void _gala_window_listener_window_removed_meta_window_unmanaged (MetaWindow* _sender, gpointer self) {
	gala_window_listener_window_removed ((GalaWindowListener*) self, _sender);
}


static void gala_window_listener_monitor_window (GalaWindowListener* self, MetaWindow* window) {
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = window;
	g_signal_connect_object ((GObject*) _tmp0_, "notify", (GCallback) _gala_window_listener_window_notify_g_object_notify, self, 0);
	_tmp1_ = window;
	g_signal_connect_object (_tmp1_, "unmanaged", (GCallback) _gala_window_listener_window_removed_meta_window_unmanaged, self, 0);
	_tmp2_ = window;
	gala_window_listener_window_maximized_changed (self, _tmp2_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void gala_window_listener_window_notify (GalaWindowListener* self, GObject* object, GParamSpec* pspec) {
	MetaWindow* window = NULL;
	GObject* _tmp0_;
	MetaWindow* _tmp1_;
	GParamSpec* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
	static GQuark _tmp5_label0 = 0;
	static GQuark _tmp5_label1 = 0;
	static GQuark _tmp5_label2 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (object != NULL);
	g_return_if_fail (pspec != NULL);
	_tmp0_ = object;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, meta_window_get_type (), MetaWindow));
	window = _tmp1_;
	_tmp2_ = pspec;
	_tmp3_ = _tmp2_->name;
	_tmp4_ = _tmp3_;
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
	if ((_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("maximized-horizontally")))) || (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("maximized-vertically"))))) {
		switch (0) {
			default:
			{
				MetaWindow* _tmp7_;
				_tmp7_ = window;
				gala_window_listener_window_maximized_changed (self, _tmp7_);
				break;
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("on-all-workspaces")))) {
		switch (0) {
			default:
			{
				MetaWindow* _tmp8_;
				_tmp8_ = window;
				gala_window_listener_window_on_all_workspaces_changed (self, _tmp8_);
				break;
			}
		}
	}
	_g_object_unref0 (window);
}


static void gala_window_listener_window_on_all_workspaces_changed (GalaWindowListener* self, MetaWindow* window) {
	MetaWindow* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	MetaWindow* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = window;
	g_object_get (_tmp0_, "on-all-workspaces", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		return;
	}
	_tmp3_ = window;
	g_signal_emit (self, gala_window_listener_signals[GALA_WINDOW_LISTENER_WINDOW_NO_LONGER_ON_ALL_WORKSPACES_SIGNAL], 0, _tmp3_);
}


static void gala_window_listener_window_maximized_changed (GalaWindowListener* self, MetaWindow* window) {
	GalaWindowGeometry window_geometry = {0};
	GalaWindowGeometry _tmp0_ = {0};
	MetaWindow* _tmp1_;
	MetaRectangle _tmp2_ = {0};
	MetaWindow* _tmp3_;
	MetaRectangle _tmp4_ = {0};
	GeeHashMap* _tmp5_;
	MetaWindow* _tmp6_;
	GalaWindowGeometry _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	window_geometry = _tmp0_;
	_tmp1_ = window;
	meta_window_get_frame_rect (_tmp1_, &_tmp2_);
	window_geometry.inner = _tmp2_;
	_tmp3_ = window;
	meta_window_get_buffer_rect (_tmp3_, &_tmp4_);
	window_geometry.outer = _tmp4_;
	_tmp5_ = self->priv->unmaximized_state_geometry;
	_tmp6_ = window;
	_tmp7_ = window_geometry;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, _tmp6_, &_tmp7_);
}


GalaWindowGeometry* gala_window_listener_get_unmaximized_state_geometry (GalaWindowListener* self, MetaWindow* window) {
	GalaWindowGeometry* result = NULL;
	GeeHashMap* _tmp0_;
	MetaWindow* _tmp1_;
	gpointer _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = self->priv->unmaximized_state_geometry;
	_tmp1_ = window;
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
	result = (GalaWindowGeometry*) _tmp2_;
	return result;
}


static void gala_window_listener_window_removed (GalaWindowListener* self, MetaWindow* window) {
	MetaWindow* _tmp0_;
	guint _tmp1_;
	MetaWindow* _tmp2_;
	guint _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = window;
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _gala_window_listener_window_notify_g_object_notify, self);
	_tmp2_ = window;
	g_signal_parse_name ("unmanaged", meta_window_get_type (), &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_window_listener_window_removed_meta_window_unmanaged, self);
}


static void gala_window_listener_class_init (GalaWindowListenerClass * klass) {
	gala_window_listener_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GalaWindowListenerPrivate));
	G_OBJECT_CLASS (klass)->finalize = gala_window_listener_finalize;
	gala_window_listener_signals[GALA_WINDOW_LISTENER_WINDOW_NO_LONGER_ON_ALL_WORKSPACES_SIGNAL] = g_signal_new ("window-no-longer-on-all-workspaces", GALA_TYPE_WINDOW_LISTENER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, meta_window_get_type ());
}


static void gala_window_listener_instance_init (GalaWindowListener * self) {
	self->priv = GALA_WINDOW_LISTENER_GET_PRIVATE (self);
}


static void gala_window_listener_finalize (GObject * obj) {
	GalaWindowListener * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_LISTENER, GalaWindowListener);
	_g_object_unref0 (self->priv->unmaximized_state_geometry);
	G_OBJECT_CLASS (gala_window_listener_parent_class)->finalize (obj);
}


GType gala_window_listener_get_type (void) {
	static volatile gsize gala_window_listener_type_id__volatile = 0;
	if (g_once_init_enter (&gala_window_listener_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWindowListenerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_listener_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowListener), 0, (GInstanceInitFunc) gala_window_listener_instance_init, NULL };
		GType gala_window_listener_type_id;
		gala_window_listener_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWindowListener", &g_define_type_info, 0);
		g_once_init_leave (&gala_window_listener_type_id__volatile, gala_window_listener_type_id);
	}
	return gala_window_listener_type_id__volatile;
}



