/* WorkspaceManager.c generated by valac 0.38.10, the Vala compiler
 * generated from WorkspaceManager.vala, do not modify */

/**/
/*  Copyright (C) 2014 Tom Beckmann, Rico Tzschichholz*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include "gala.h"
#include <gee.h>
#include <meta/workspace.h>
#include <meta/screen.h>
#include <meta/meta-plugin.h>
#include <meta/prefs.h>
#include <meta/common.h>
#include <meta/window.h>
#include <meta/display.h>


#define GALA_TYPE_WORKSPACE_MANAGER (gala_workspace_manager_get_type ())
#define GALA_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager))
#define GALA_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))
#define GALA_IS_WORKSPACE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_IS_WORKSPACE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WORKSPACE_MANAGER))
#define GALA_WORKSPACE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerClass))

typedef struct _GalaWorkspaceManager GalaWorkspaceManager;
typedef struct _GalaWorkspaceManagerClass GalaWorkspaceManagerClass;
typedef struct _GalaWorkspaceManagerPrivate GalaWorkspaceManagerPrivate;
enum  {
	GALA_WORKSPACE_MANAGER_0_PROPERTY,
	GALA_WORKSPACE_MANAGER_WM_PROPERTY,
	GALA_WORKSPACE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GalaWorkspaceManager {
	GObject parent_instance;
	GalaWorkspaceManagerPrivate * priv;
};

struct _GalaWorkspaceManagerClass {
	GObjectClass parent_class;
};

struct _GalaWorkspaceManagerPrivate {
	GalaWindowManager* _wm;
	GeeLinkedList* workspaces_marked_removed;
	gint remove_freeze_count;
};


static gpointer gala_workspace_manager_parent_class = NULL;
static GalaWorkspaceManager* gala_workspace_manager_instance;
static GalaWorkspaceManager* gala_workspace_manager_instance = NULL;

GType gala_workspace_manager_get_type (void) G_GNUC_CONST;
#define GALA_WORKSPACE_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManagerPrivate))
GalaWindowManager* gala_workspace_manager_get_wm (GalaWorkspaceManager* self);
static void gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self, MetaPreference pref);
static void _gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref, gpointer self);
static void gala_workspace_manager_workspace_added (GalaWorkspaceManager* self, MetaScreen* screen, gint index);
static void _gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender, gint object, gpointer self);
static void gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self, MetaScreen* screen, gint from, gint to, MetaMotionDirection direction);
static void _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender, gint object, gint p0, MetaMotionDirection p1, gpointer self);
static void gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self, MetaScreen* screen, gint index);
static void _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender, gint object, gpointer self);
static void gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self, MetaScreen* screen, gint monitor, MetaWindow* window);
static void _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender, gint object, MetaWindow* p0, gpointer self);
static void gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self, MetaScreen* screen, gint monitor, MetaWindow* window);
static void _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender, gint object, MetaWindow* p0, gpointer self);
void gala_workspace_manager_init (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_new (GalaWindowManager* wm);
static GalaWorkspaceManager* gala_workspace_manager_construct (GType object_type, GalaWindowManager* wm);
GalaWorkspaceManager* gala_workspace_manager_get_default (void);
static void gala_workspace_manager_window_added (GalaWorkspaceManager* self, MetaWorkspace* workspace, MetaWindow* window);
static void _gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender, MetaWindow* object, gpointer self);
static void gala_workspace_manager_window_removed (GalaWorkspaceManager* self, MetaWorkspace* workspace, MetaWindow* window);
static void _gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender, MetaWindow* object, gpointer self);
static void gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self, MetaWorkspace* workspace);
static void gala_workspace_manager_append_workspace (GalaWorkspaceManager* self);
gboolean gala_internal_utils_workspaces_only_on_primary (void);
void gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self);
void gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self);
void gala_workspace_manager_cleanup (GalaWorkspaceManager* self);
static void gala_workspace_manager_set_wm (GalaWorkspaceManager* self, GalaWindowManager* value);
static GObject * gala_workspace_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void gala_workspace_manager_finalize (GObject * obj);
static void _vala_gala_workspace_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gala_workspace_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _gala_workspace_manager_prefs_listener_meta_prefs_changed_func (MetaPreference pref, gpointer self) {
	gala_workspace_manager_prefs_listener ((GalaWorkspaceManager*) self, pref);
}


static void _gala_workspace_manager_workspace_added_meta_screen_workspace_added (MetaScreen* _sender, gint object, gpointer self) {
	gala_workspace_manager_workspace_added ((GalaWorkspaceManager*) self, _sender, object);
}


static void _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched (MetaScreen* _sender, gint object, gint p0, MetaMotionDirection p1, gpointer self) {
	gala_workspace_manager_workspace_switched ((GalaWorkspaceManager*) self, _sender, object, p0, p1);
}


static void _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed (MetaScreen* _sender, gint object, gpointer self) {
	gala_workspace_manager_workspace_removed ((GalaWorkspaceManager*) self, _sender, object);
}


static void _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor (MetaScreen* _sender, gint object, MetaWindow* p0, gpointer self) {
	gala_workspace_manager_window_entered_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
}


static void _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor (MetaScreen* _sender, gint object, MetaWindow* p0, gpointer self) {
	gala_workspace_manager_window_left_monitor ((GalaWorkspaceManager*) self, _sender, object, p0);
}


void gala_workspace_manager_init (GalaWindowManager* wm) {
	GalaWorkspaceManager* _tmp0_;
	GalaWindowManager* _tmp1_;
	GalaWorkspaceManager* _tmp2_;
	g_return_if_fail (wm != NULL);
	_tmp0_ = gala_workspace_manager_instance;
	_vala_return_if_fail (_tmp0_ == NULL, "instance == null");
	_tmp1_ = wm;
	_tmp2_ = gala_workspace_manager_new (_tmp1_);
	_g_object_unref0 (gala_workspace_manager_instance);
	gala_workspace_manager_instance = _tmp2_;
}


GalaWorkspaceManager* gala_workspace_manager_get_default (void) {
	GalaWorkspaceManager* result = NULL;
	GalaWorkspaceManager* _tmp0_;
	GalaWorkspaceManager* _tmp1_;
	_tmp0_ = gala_workspace_manager_instance;
	_vala_return_val_if_fail (_tmp0_ != NULL, "instance != null", NULL);
	_tmp1_ = gala_workspace_manager_instance;
	result = _tmp1_;
	return result;
}


static GalaWorkspaceManager* gala_workspace_manager_construct (GType object_type, GalaWindowManager* wm) {
	GalaWorkspaceManager * self = NULL;
	GalaWindowManager* _tmp0_;
	g_return_val_if_fail (wm != NULL, NULL);
	_tmp0_ = wm;
	self = (GalaWorkspaceManager*) g_object_new (object_type, "wm", _tmp0_, NULL);
	return self;
}


static GalaWorkspaceManager* gala_workspace_manager_new (GalaWindowManager* wm) {
	return gala_workspace_manager_construct (GALA_TYPE_WORKSPACE_MANAGER, wm);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _gala_workspace_manager_window_added_meta_workspace_window_added (MetaWorkspace* _sender, MetaWindow* object, gpointer self) {
	gala_workspace_manager_window_added ((GalaWorkspaceManager*) self, _sender, object);
}


static void _gala_workspace_manager_window_removed_meta_workspace_window_removed (MetaWorkspace* _sender, MetaWindow* object, gpointer self) {
	gala_workspace_manager_window_removed ((GalaWorkspaceManager*) self, _sender, object);
}


static void gala_workspace_manager_workspace_added (GalaWorkspaceManager* self, MetaScreen* screen, gint index) {
	MetaWorkspace* workspace = NULL;
	MetaScreen* _tmp0_;
	gint _tmp1_;
	MetaWorkspace* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
	MetaWorkspace* _tmp5_;
	MetaWorkspace* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	_tmp0_ = screen;
	_tmp1_ = index;
	_tmp2_ = meta_screen_get_workspace_by_index (_tmp0_, _tmp1_);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	workspace = _tmp3_;
	_tmp4_ = workspace;
	if (_tmp4_ == NULL) {
		_g_object_unref0 (workspace);
		return;
	}
	_tmp5_ = workspace;
	g_signal_connect_object (_tmp5_, "window-added", (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self, 0);
	_tmp6_ = workspace;
	g_signal_connect_object (_tmp6_, "window-removed", (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self, 0);
	_g_object_unref0 (workspace);
}


static void gala_workspace_manager_workspace_removed (GalaWorkspaceManager* self, MetaScreen* screen, gint index) {
	GList* existing_workspaces = NULL;
	MetaScreen* _tmp0_;
	GList* _tmp1_;
	GeeIterator* it = NULL;
	GeeLinkedList* _tmp2_;
	GeeIterator* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	_tmp0_ = screen;
	_tmp1_ = meta_screen_get_workspaces (_tmp0_);
	existing_workspaces = _tmp1_;
	_tmp2_ = self->priv->workspaces_marked_removed;
	_tmp3_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp2_);
	it = _tmp3_;
	while (TRUE) {
		GeeIterator* _tmp4_;
		gboolean _tmp5_;
		GList* _tmp6_;
		GeeIterator* _tmp7_;
		gpointer _tmp8_;
		MetaWorkspace* _tmp9_;
		gint _tmp10_;
		gboolean _tmp11_;
		_tmp4_ = it;
		_tmp5_ = gee_iterator_next (_tmp4_);
		if (!_tmp5_) {
			break;
		}
		_tmp6_ = existing_workspaces;
		_tmp7_ = it;
		_tmp8_ = gee_iterator_get (_tmp7_);
		_tmp9_ = (MetaWorkspace*) _tmp8_;
		_tmp10_ = g_list_index (_tmp6_, _tmp9_);
		_tmp11_ = _tmp10_ < 0;
		_g_object_unref0 (_tmp9_);
		if (_tmp11_) {
			GeeIterator* _tmp12_;
			_tmp12_ = it;
			gee_iterator_remove (_tmp12_);
		}
	}
	_g_object_unref0 (it);
}


static void gala_workspace_manager_workspace_switched (GalaWorkspaceManager* self, MetaScreen* screen, gint from, gint to, MetaMotionDirection direction) {
	gboolean _tmp0_;
	MetaWorkspace* prev_workspace = NULL;
	MetaScreen* _tmp1_;
	gint _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* _tmp4_;
	gboolean _tmp5_ = FALSE;
	MetaWorkspace* _tmp6_;
	guint _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	_tmp0_ = meta_prefs_get_dynamic_workspaces ();
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = screen;
	_tmp2_ = from;
	_tmp3_ = meta_screen_get_workspace_by_index (_tmp1_, _tmp2_);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	prev_workspace = _tmp4_;
	_tmp6_ = prev_workspace;
	_tmp7_ = gala_utils_get_n_windows (_tmp6_);
	if (_tmp7_ < ((guint) 1)) {
		gint _tmp8_;
		MetaScreen* _tmp9_;
		gint _tmp10_;
		_tmp8_ = from;
		_tmp9_ = screen;
		_tmp10_ = meta_screen_get_n_workspaces (_tmp9_);
		_tmp5_ = _tmp8_ != (_tmp10_ - 1);
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		MetaWorkspace* _tmp11_;
		_tmp11_ = prev_workspace;
		gala_workspace_manager_remove_workspace (self, _tmp11_);
	}
	_g_object_unref0 (prev_workspace);
}


static void gala_workspace_manager_window_added (GalaWorkspaceManager* self, MetaWorkspace* workspace, MetaWindow* window) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	MetaWorkspace* _tmp2_;
	MetaScreen* screen = NULL;
	MetaWorkspace* _tmp7_;
	MetaScreen* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	MetaWindow* _tmp12_;
	MetaWindowType _tmp13_;
	MetaWindowType _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp2_ = workspace;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp3_;
		_tmp3_ = meta_prefs_get_dynamic_workspaces ();
		_tmp1_ = !_tmp3_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		MetaWindow* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = window;
		g_object_get (_tmp4_, "on-all-workspaces", &_tmp5_, NULL);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp7_ = workspace;
	_tmp8_ = meta_workspace_get_screen (_tmp7_);
	screen = _tmp8_;
	_tmp12_ = window;
	_tmp13_ = meta_window_get_window_type (_tmp12_);
	_tmp14_ = _tmp13_;
	if (_tmp14_ == META_WINDOW_NORMAL) {
		_tmp11_ = TRUE;
	} else {
		MetaWindow* _tmp15_;
		MetaWindowType _tmp16_;
		MetaWindowType _tmp17_;
		_tmp15_ = window;
		_tmp16_ = meta_window_get_window_type (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp11_ = _tmp17_ == META_WINDOW_DIALOG;
	}
	if (_tmp11_) {
		_tmp10_ = TRUE;
	} else {
		MetaWindow* _tmp18_;
		MetaWindowType _tmp19_;
		MetaWindowType _tmp20_;
		_tmp18_ = window;
		_tmp19_ = meta_window_get_window_type (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp10_ = _tmp20_ == META_WINDOW_MODAL_DIALOG;
	}
	if (_tmp10_) {
		MetaWorkspace* _tmp21_;
		gint _tmp22_;
		MetaScreen* _tmp23_;
		gint _tmp24_;
		_tmp21_ = workspace;
		_tmp22_ = meta_workspace_index (_tmp21_);
		_tmp23_ = screen;
		_tmp24_ = meta_screen_get_n_workspaces (_tmp23_);
		_tmp9_ = _tmp22_ == (_tmp24_ - 1);
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		gala_workspace_manager_append_workspace (self);
	}
}


static void gala_workspace_manager_window_removed (GalaWorkspaceManager* self, MetaWorkspace* workspace, MetaWindow* window) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	MetaWorkspace* _tmp2_;
	MetaScreen* screen = NULL;
	MetaWorkspace* _tmp7_;
	MetaScreen* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	MetaWindow* _tmp11_;
	MetaWindowType _tmp12_;
	MetaWindowType _tmp13_;
	gint index = 0;
	MetaScreen* _tmp20_;
	GList* _tmp21_;
	MetaWorkspace* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gboolean is_active_workspace = FALSE;
	MetaWorkspace* _tmp25_;
	MetaScreen* _tmp26_;
	MetaWorkspace* _tmp27_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp2_ = workspace;
	if (_tmp2_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp3_;
		_tmp3_ = meta_prefs_get_dynamic_workspaces ();
		_tmp1_ = !_tmp3_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		MetaWindow* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = window;
		g_object_get (_tmp4_, "on-all-workspaces", &_tmp5_, NULL);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp7_ = workspace;
	_tmp8_ = meta_workspace_get_screen (_tmp7_);
	screen = _tmp8_;
	_tmp11_ = window;
	_tmp12_ = meta_window_get_window_type (_tmp11_);
	_tmp13_ = _tmp12_;
	if (_tmp13_ != META_WINDOW_NORMAL) {
		MetaWindow* _tmp14_;
		MetaWindowType _tmp15_;
		MetaWindowType _tmp16_;
		_tmp14_ = window;
		_tmp15_ = meta_window_get_window_type (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp10_ = _tmp16_ != META_WINDOW_DIALOG;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		MetaWindow* _tmp17_;
		MetaWindowType _tmp18_;
		MetaWindowType _tmp19_;
		_tmp17_ = window;
		_tmp18_ = meta_window_get_window_type (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp9_ = _tmp19_ != META_WINDOW_MODAL_DIALOG;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		return;
	}
	_tmp20_ = screen;
	_tmp21_ = meta_screen_get_workspaces (_tmp20_);
	_tmp22_ = workspace;
	_tmp23_ = g_list_index (_tmp21_, _tmp22_);
	index = _tmp23_;
	_tmp24_ = index;
	if (_tmp24_ < 0) {
		return;
	}
	_tmp25_ = workspace;
	_tmp26_ = screen;
	_tmp27_ = meta_screen_get_active_workspace (_tmp26_);
	is_active_workspace = _tmp25_ == _tmp27_;
	_tmp32_ = is_active_workspace;
	if (!_tmp32_) {
		_tmp31_ = TRUE;
	} else {
		GalaWindowManager* _tmp33_;
		gboolean _tmp34_;
		_tmp33_ = self->priv->_wm;
		_tmp34_ = gala_window_manager_is_modal (_tmp33_);
		_tmp31_ = _tmp34_;
	}
	if (_tmp31_) {
		gint _tmp35_;
		_tmp35_ = self->priv->remove_freeze_count;
		_tmp30_ = _tmp35_ < 1;
	} else {
		_tmp30_ = FALSE;
	}
	if (_tmp30_) {
		MetaWorkspace* _tmp36_;
		guint _tmp37_;
		_tmp36_ = workspace;
		_tmp37_ = gala_utils_get_n_windows (_tmp36_);
		_tmp29_ = _tmp37_ < ((guint) 1);
	} else {
		_tmp29_ = FALSE;
	}
	if (_tmp29_) {
		gint _tmp38_;
		MetaScreen* _tmp39_;
		gint _tmp40_;
		_tmp38_ = index;
		_tmp39_ = screen;
		_tmp40_ = meta_screen_get_n_workspaces (_tmp39_);
		_tmp28_ = _tmp38_ != (_tmp40_ - 1);
	} else {
		_tmp28_ = FALSE;
	}
	if (_tmp28_) {
		MetaWorkspace* _tmp41_;
		_tmp41_ = workspace;
		gala_workspace_manager_remove_workspace (self, _tmp41_);
	}
}


static void gala_workspace_manager_window_entered_monitor (GalaWorkspaceManager* self, MetaScreen* screen, gint monitor, MetaWindow* window) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	g_return_if_fail (window != NULL);
	_tmp1_ = gala_internal_utils_workspaces_only_on_primary ();
	if (_tmp1_) {
		gint _tmp2_;
		MetaScreen* _tmp3_;
		gint _tmp4_;
		_tmp2_ = monitor;
		_tmp3_ = screen;
		_tmp4_ = meta_screen_get_primary_monitor (_tmp3_);
		_tmp0_ = _tmp2_ == _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		MetaWindow* _tmp5_;
		MetaWorkspace* _tmp6_;
		MetaWindow* _tmp7_;
		_tmp5_ = window;
		_tmp6_ = meta_window_get_workspace (_tmp5_);
		_tmp7_ = window;
		gala_workspace_manager_window_added (self, _tmp6_, _tmp7_);
	}
}


static void gala_workspace_manager_window_left_monitor (GalaWorkspaceManager* self, MetaScreen* screen, gint monitor, MetaWindow* window) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	g_return_if_fail (window != NULL);
	_tmp1_ = gala_internal_utils_workspaces_only_on_primary ();
	if (_tmp1_) {
		gint _tmp2_;
		MetaScreen* _tmp3_;
		gint _tmp4_;
		_tmp2_ = monitor;
		_tmp3_ = screen;
		_tmp4_ = meta_screen_get_primary_monitor (_tmp3_);
		_tmp0_ = _tmp2_ == _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		MetaWindow* _tmp5_;
		MetaWorkspace* _tmp6_;
		MetaWindow* _tmp7_;
		_tmp5_ = window;
		_tmp6_ = meta_window_get_workspace (_tmp5_);
		_tmp7_ = window;
		gala_workspace_manager_window_removed (self, _tmp6_, _tmp7_);
	}
}


static void gala_workspace_manager_prefs_listener (GalaWorkspaceManager* self, MetaPreference pref) {
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	gboolean _tmp2_ = FALSE;
	MetaPreference _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	screen = _tmp1_;
	_tmp3_ = pref;
	if (_tmp3_ == META_PREF_DYNAMIC_WORKSPACES) {
		gboolean _tmp4_;
		_tmp4_ = meta_prefs_get_dynamic_workspaces ();
		_tmp2_ = _tmp4_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		MetaScreen* _tmp5_;
		MetaScreen* _tmp6_;
		gint _tmp7_;
		MetaWorkspace* _tmp8_;
		guint _tmp9_;
		_tmp5_ = screen;
		_tmp6_ = screen;
		_tmp7_ = meta_screen_get_n_workspaces (_tmp6_);
		_tmp8_ = meta_screen_get_workspace_by_index (_tmp5_, _tmp7_ - 1);
		_tmp9_ = gala_utils_get_n_windows (_tmp8_);
		if (_tmp9_ > ((guint) 0)) {
			gala_workspace_manager_append_workspace (self);
		}
	}
}


static void gala_workspace_manager_append_workspace (GalaWorkspaceManager* self) {
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaDisplay* _tmp2_;
	guint32 _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	screen = _tmp1_;
	_tmp2_ = meta_screen_get_display (screen);
	_tmp3_ = meta_display_get_current_time (_tmp2_);
	meta_screen_append_new_workspace (screen, FALSE, _tmp3_);
}


/**
 * Make sure we switch to a different workspace and remove the given one
 *
 * @param workspace The workspace to remove
 */
static void gala_workspace_manager_remove_workspace (GalaWorkspaceManager* self, MetaWorkspace* workspace) {
	MetaScreen* screen = NULL;
	MetaWorkspace* _tmp0_;
	MetaScreen* _tmp1_;
	guint32 time = 0U;
	MetaScreen* _tmp2_;
	MetaDisplay* _tmp3_;
	guint32 _tmp4_;
	MetaWorkspace* _tmp5_;
	MetaScreen* _tmp6_;
	MetaWorkspace* _tmp7_;
	GeeLinkedList* _tmp21_;
	MetaWorkspace* _tmp22_;
	gboolean _tmp23_;
	MetaWorkspace* _tmp24_;
	guint _tmp25_;
	MetaWorkspace* _tmp26_;
	guint _tmp27_;
	GeeLinkedList* _tmp28_;
	MetaWorkspace* _tmp29_;
	MetaScreen* _tmp30_;
	MetaWorkspace* _tmp31_;
	guint32 _tmp32_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (workspace != NULL);
	_tmp0_ = workspace;
	_tmp1_ = meta_workspace_get_screen (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = screen;
	_tmp3_ = meta_screen_get_display (_tmp2_);
	_tmp4_ = meta_display_get_current_time (_tmp3_);
	time = _tmp4_;
	_tmp5_ = workspace;
	_tmp6_ = screen;
	_tmp7_ = meta_screen_get_active_workspace (_tmp6_);
	if (_tmp5_ == _tmp7_) {
		MetaWorkspace* next = NULL;
		MetaWorkspace* _tmp8_;
		MetaWorkspace* _tmp9_;
		MetaWorkspace* _tmp10_;
		gboolean _tmp11_ = FALSE;
		MetaWorkspace* _tmp12_;
		MetaWorkspace* _tmp13_;
		MetaWorkspace* _tmp18_;
		next = NULL;
		_tmp8_ = workspace;
		_tmp9_ = meta_workspace_get_neighbor (_tmp8_, META_MOTION_LEFT);
		_tmp10_ = _g_object_ref0 (_tmp9_);
		_g_object_unref0 (next);
		next = _tmp10_;
		_tmp12_ = next;
		_tmp13_ = workspace;
		if (_tmp12_ == _tmp13_) {
			_tmp11_ = TRUE;
		} else {
			MetaWorkspace* _tmp14_;
			_tmp14_ = next;
			_tmp11_ = _tmp14_ == NULL;
		}
		if (_tmp11_) {
			MetaWorkspace* _tmp15_;
			MetaWorkspace* _tmp16_;
			MetaWorkspace* _tmp17_;
			_tmp15_ = workspace;
			_tmp16_ = meta_workspace_get_neighbor (_tmp15_, META_MOTION_RIGHT);
			_tmp17_ = _g_object_ref0 (_tmp16_);
			_g_object_unref0 (next);
			next = _tmp17_;
		}
		_tmp18_ = next;
		if (_tmp18_ != NULL) {
			MetaWorkspace* _tmp19_;
			guint32 _tmp20_;
			_tmp19_ = next;
			_tmp20_ = time;
			meta_workspace_activate (_tmp19_, _tmp20_);
		}
		_g_object_unref0 (next);
	}
	_tmp21_ = self->priv->workspaces_marked_removed;
	_tmp22_ = workspace;
	_tmp23_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp21_, _tmp22_);
	if (_tmp23_) {
		return;
	}
	_tmp24_ = workspace;
	g_signal_parse_name ("window-added", meta_workspace_get_type (), &_tmp25_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _gala_workspace_manager_window_added_meta_workspace_window_added, self);
	_tmp26_ = workspace;
	g_signal_parse_name ("window-removed", meta_workspace_get_type (), &_tmp27_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp26_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp27_, 0, NULL, (GCallback) _gala_workspace_manager_window_removed_meta_workspace_window_removed, self);
	_tmp28_ = self->priv->workspaces_marked_removed;
	_tmp29_ = workspace;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
	_tmp30_ = screen;
	_tmp31_ = workspace;
	_tmp32_ = time;
	meta_screen_remove_workspace (_tmp30_, _tmp31_, _tmp32_);
}


/**
 * Temporarily disables removing workspaces when they are empty
 */
void gala_workspace_manager_freeze_remove (GalaWorkspaceManager* self) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->remove_freeze_count;
	self->priv->remove_freeze_count = _tmp0_ + 1;
}


/**
 * Undo the effect of freeze_remove()
 */
void gala_workspace_manager_thaw_remove (GalaWorkspaceManager* self) {
	gint _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->remove_freeze_count;
	self->priv->remove_freeze_count = _tmp0_ - 1;
	_tmp1_ = self->priv->remove_freeze_count;
	_vala_assert (_tmp1_ >= 0, "remove_freeze_count >= 0");
}


/**
 * If workspaces are dynamic, checks if there are empty workspaces that should
 * be removed. Particularily useful in conjunction with freeze/thaw_remove to
 * cleanup after an operation that required stable workspace/window indices
 */
void gala_workspace_manager_cleanup (GalaWorkspaceManager* self) {
	gboolean _tmp0_;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp1_;
	MetaScreen* _tmp2_;
	MetaScreen* _tmp3_;
	gint last_index = 0;
	MetaScreen* _tmp4_;
	gint _tmp5_;
	MetaScreen* _tmp6_;
	GList* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = meta_prefs_get_dynamic_workspaces ();
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->_wm;
	_tmp2_ = meta_plugin_get_screen ((MetaPlugin*) _tmp1_);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	screen = _tmp3_;
	_tmp4_ = screen;
	_tmp5_ = meta_screen_get_n_workspaces (_tmp4_);
	last_index = _tmp5_ - 1;
	_tmp6_ = screen;
	_tmp7_ = meta_screen_get_workspaces (_tmp6_);
	{
		GList* workspace_collection = NULL;
		GList* workspace_it = NULL;
		workspace_collection = _tmp7_;
		for (workspace_it = workspace_collection; workspace_it != NULL; workspace_it = workspace_it->next) {
			MetaWorkspace* _tmp8_;
			MetaWorkspace* workspace = NULL;
			_tmp8_ = _g_object_ref0 ((MetaWorkspace*) workspace_it->data);
			workspace = _tmp8_;
			{
				gboolean _tmp9_ = FALSE;
				MetaWorkspace* _tmp10_;
				guint _tmp11_;
				_tmp10_ = workspace;
				_tmp11_ = gala_utils_get_n_windows (_tmp10_);
				if (_tmp11_ < ((guint) 1)) {
					MetaWorkspace* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = workspace;
					_tmp13_ = meta_workspace_index (_tmp12_);
					_tmp14_ = last_index;
					_tmp9_ = _tmp13_ != _tmp14_;
				} else {
					_tmp9_ = FALSE;
				}
				if (_tmp9_) {
					MetaWorkspace* _tmp15_;
					_tmp15_ = workspace;
					gala_workspace_manager_remove_workspace (self, _tmp15_);
				}
				_g_object_unref0 (workspace);
			}
		}
	}
	_g_object_unref0 (screen);
}


GalaWindowManager* gala_workspace_manager_get_wm (GalaWorkspaceManager* self) {
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_wm;
	result = _tmp0_;
	return result;
}


static void gala_workspace_manager_set_wm (GalaWorkspaceManager* self, GalaWindowManager* value) {
	g_return_if_fail (self != NULL);
	if (gala_workspace_manager_get_wm (self) != value) {
		GalaWindowManager* _tmp0_;
		GalaWindowManager* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_g_object_unref0 (self->priv->_wm);
		self->priv->_wm = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY]);
	}
}


static GObject * gala_workspace_manager_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	GeeLinkedList* _tmp2_;
	gboolean _tmp3_;
	MetaScreen* _tmp12_;
	MetaScreen* _tmp13_;
	MetaScreen* _tmp14_;
	MetaScreen* _tmp15_;
	MetaScreen* _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_;
	parent_class = G_OBJECT_CLASS (gala_workspace_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	screen = _tmp1_;
	_tmp2_ = gee_linked_list_new (meta_workspace_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->workspaces_marked_removed);
	self->priv->workspaces_marked_removed = _tmp2_;
	_tmp3_ = meta_prefs_get_dynamic_workspaces ();
	if (_tmp3_) {
		MetaScreen* _tmp4_;
		_tmp4_ = screen;
		meta_screen_override_workspace_layout (_tmp4_, META_SCREEN_TOPLEFT, FALSE, 1, -1);
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				MetaScreen* _tmp8_;
				gint _tmp9_;
				MetaScreen* _tmp10_;
				gint _tmp11_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = i;
				_tmp8_ = screen;
				_tmp9_ = meta_screen_get_n_workspaces (_tmp8_);
				if (!(_tmp7_ < _tmp9_)) {
					break;
				}
				_tmp10_ = screen;
				_tmp11_ = i;
				gala_workspace_manager_workspace_added (self, _tmp10_, _tmp11_);
			}
		}
	}
	meta_prefs_add_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
	_tmp12_ = screen;
	g_signal_connect_object (_tmp12_, "workspace-switched", (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self, G_CONNECT_AFTER);
	_tmp13_ = screen;
	g_signal_connect_object (_tmp13_, "workspace-added", (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self, 0);
	_tmp14_ = screen;
	g_signal_connect_object (_tmp14_, "workspace-removed", (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self, G_CONNECT_AFTER);
	_tmp15_ = screen;
	g_signal_connect_object (_tmp15_, "window-entered-monitor", (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self, 0);
	_tmp16_ = screen;
	g_signal_connect_object (_tmp16_, "window-left-monitor", (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self, 0);
	_tmp18_ = meta_prefs_get_dynamic_workspaces ();
	if (_tmp18_) {
		MetaScreen* _tmp19_;
		MetaScreen* _tmp20_;
		gint _tmp21_;
		MetaWorkspace* _tmp22_;
		guint _tmp23_;
		_tmp19_ = screen;
		_tmp20_ = screen;
		_tmp21_ = meta_screen_get_n_workspaces (_tmp20_);
		_tmp22_ = meta_screen_get_workspace_by_index (_tmp19_, _tmp21_ - 1);
		_tmp23_ = gala_utils_get_n_windows (_tmp22_);
		_tmp17_ = _tmp23_ > ((guint) 0);
	} else {
		_tmp17_ = FALSE;
	}
	if (_tmp17_) {
		gala_workspace_manager_append_workspace (self);
	}
	gala_workspace_manager_cleanup (self);
	return obj;
}


static void gala_workspace_manager_class_init (GalaWorkspaceManagerClass * klass) {
	gala_workspace_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GalaWorkspaceManagerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_workspace_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_workspace_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_workspace_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_workspace_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WORKSPACE_MANAGER_WM_PROPERTY, gala_workspace_manager_properties[GALA_WORKSPACE_MANAGER_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void gala_workspace_manager_instance_init (GalaWorkspaceManager * self) {
	self->priv = GALA_WORKSPACE_MANAGER_GET_PRIVATE (self);
	self->priv->remove_freeze_count = 0;
}


static void gala_workspace_manager_finalize (GObject * obj) {
	GalaWorkspaceManager * self;
	MetaScreen* screen = NULL;
	GalaWindowManager* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	guint _tmp3_;
	MetaScreen* _tmp4_;
	guint _tmp5_;
	MetaScreen* _tmp6_;
	guint _tmp7_;
	MetaScreen* _tmp8_;
	guint _tmp9_;
	MetaScreen* _tmp10_;
	guint _tmp11_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
	_tmp0_ = self->priv->_wm;
	_tmp1_ = meta_plugin_get_screen ((MetaPlugin*) _tmp0_);
	screen = _tmp1_;
	meta_prefs_remove_listener (_gala_workspace_manager_prefs_listener_meta_prefs_changed_func, self);
	_tmp2_ = screen;
	g_signal_parse_name ("workspace-added", meta_screen_get_type (), &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_added_meta_screen_workspace_added, self);
	_tmp4_ = screen;
	g_signal_parse_name ("workspace-switched", meta_screen_get_type (), &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_switched_meta_screen_workspace_switched, self);
	_tmp6_ = screen;
	g_signal_parse_name ("workspace-removed", meta_screen_get_type (), &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _gala_workspace_manager_workspace_removed_meta_screen_workspace_removed, self);
	_tmp8_ = screen;
	g_signal_parse_name ("window-entered-monitor", meta_screen_get_type (), &_tmp9_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _gala_workspace_manager_window_entered_monitor_meta_screen_window_entered_monitor, self);
	_tmp10_ = screen;
	g_signal_parse_name ("window-left-monitor", meta_screen_get_type (), &_tmp11_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _gala_workspace_manager_window_left_monitor_meta_screen_window_left_monitor, self);
	_g_object_unref0 (self->priv->_wm);
	_g_object_unref0 (self->priv->workspaces_marked_removed);
	G_OBJECT_CLASS (gala_workspace_manager_parent_class)->finalize (obj);
}


GType gala_workspace_manager_get_type (void) {
	static volatile gsize gala_workspace_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gala_workspace_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaWorkspaceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_workspace_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWorkspaceManager), 0, (GInstanceInitFunc) gala_workspace_manager_instance_init, NULL };
		GType gala_workspace_manager_type_id;
		gala_workspace_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWorkspaceManager", &g_define_type_info, 0);
		g_once_init_leave (&gala_workspace_manager_type_id__volatile, gala_workspace_manager_type_id);
	}
	return gala_workspace_manager_type_id__volatile;
}


static void _vala_gala_workspace_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
	switch (property_id) {
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
		g_value_set_object (value, gala_workspace_manager_get_wm (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gala_workspace_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GalaWorkspaceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WORKSPACE_MANAGER, GalaWorkspaceManager);
	switch (property_id) {
		case GALA_WORKSPACE_MANAGER_WM_PROPERTY:
		gala_workspace_manager_set_wm (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



